<?php
/* 
Editor of WWLabor 
https://www.mwiede.de/windows-php-webserver/wwlabor.htm
*/

require_once ("main.inc.php");
require_once ($CONFIG_GLOBAL["wwadmin_path"]."/class.wwadminsesison.inc.php");
$session = new WWAdminSession ();
if (!$session->isLogin ()) {
	die ("Login with http://".$_SERVER["HTTP_HOST"]."/wwadmin/");
}

$fi = pathinfo ($filename);
$scriptType = "";
if (isset ($fi["extension"])) {
	$fi["extension"] = strtolower ($fi["extension"]);
	if (isset ($CONFIG_GLOBAL["editor_types"][$fi["extension"]])) {
			$scriptType = $CONFIG_GLOBAL["editor_types"][$fi["extension"]];
	}
}
?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>WScript Editor</title>
<meta name="robots" content="noindex,nofollow" />
<script type="text/javascript" src="wlib/js/jquery/jquery.min.js"></script>
<script type="text/javascript" src="js/utils.js"></script>
<style type="text/css" media="screen">
body {
margin:0px;
padding:0;
font-family:Arial,sans-serif;
background-color:#FFFFFF;
}
#editor { 
	position:absolute;
	left:0px;
	width:100%;
	height:95%;
	font-size:15px;
}

.toolbar {
	height:30px;
	text-align:right;
	background-color:#868686;
	color:#FFFFFF;
}

.toolbar button {
	height:30px;
	font-size:13pt;
	line-height:25px;
}

.toolbar span {
	padding-right:20px;
	vertical-align:top;
	line-height:30px;
}

.toolbar a {
	color:white;
}

.script_output {
	width:100%;
	height:100%;
	margin:0px;
	padding:0px;
}
</style>
</head>
<body>

<html>
<?php
if (is_file ($filename) && !empty ($scriptType)) {
?>
<div class="toolbar"><span><a target="_blank" href="<?php echo htmlspecialchars ($filename); ?>"><?php echo htmlspecialchars ($filename); ?></a></span><button onclick="saveEditor('<?php echo $filename; ?>');return false;">Save +  Run</button></div>
<div id="editor" style="white-space: pre;"><?php 
	$scriptCode = file_get_contents ($filename);
	echo str_replace (array ("<", ">"), array ("&lt;", "&gt;"), $scriptCode);
?>
</div>
<script src="js/ace-builds-master/src-min/ace.js" type="text/javascript" charset="utf-8"></script>
<script src="js/ace-builds-master/src-min/ext-static_highlight.js"></script>
<script type="text/javascript">
    var editor = ace.edit("editor");
    editor.setTheme("ace/theme/eclipse");
    editor.getSession().setMode("ace/mode/<?php echo $scriptType;?>"); // c_cpp
//    document.getElementById('editor').style.fontSize='15px';
		editor.commands.addCommand({
		    name: 'saveDocument',
		    bindKey: {win: 'Ctrl-S'/*,  mac: 'Command-M' */},
		    exec: function(editor) {
		    	saveEditor('<?php echo $filename; ?>');
		    },
		    readOnly: false // false if this command should not apply in readOnly mode
		});    
    
//    editor.setOption("maxLines", 110);
</script>
<?php
}
else {
	if (!is_dir ($filename) && empty ($scriptType)) {
?>
<div class="toolbar"><span>File type is not supported for editor: <?php echo htmlspecialchars ($filename); ?></span></div>
<?php
	}
	else {
?>  
	<div class="toolbar"><span>Please select file on left side</span></div>
<?php
	}
}
?>

</body>
</html>

