<?php

function getIndexFile ($dir) {
	$checkExt = array ("html", "php", "pl", "rb", "py");
	foreach ($checkExt as $ext) {
		if (is_file ($dir."/index.".$ext)) {
			return "index.".$ext;
		}
	}
	return "";
}
	
function createSecurePath ($path) {
	$docRoot = $_SERVER["DOCUMENT_ROOT"];	
	$path = str_replace (array ("\\"), array("/"), $path); 
	$p = strpos ($path, ".");
	if ($p!==false && $p==0)
		return "";
	if (file_exists ($path)) {
		// Security check if path is outside root directory
		$realPath = realpath ($docRoot."/".$path);
		if (empty ($realPath)) {
			$realPath = $docRoot."/".$path;
		}
		$realPath = str_replace (array ("\\"), array("/"), $realPath); 
		$p = strpos ($realPath, $docRoot."/".SCRIPT_PATH); 
		if ($p===false || $p>0) {
			return ""; // Path is outside script directory
		}	
	}
	return $path;
}

function getFileCSSClass ($ext) {

	$ext = strtolower ($ext);
  if (!empty ($ext)) {
  	$classList = array (
  		"jpg,gif,png,bmp" => "img",
  		"cpp,c" => "cpp",
  		"h" => "h",
  		"php" => "php",
  		"pl" => "perl",
  		"py" => "python",
  		"rb" => "ruby"
  	);	
  	foreach ($classList as $check => $class) {
  		if (strpos ($check, $ext)!==false)
  			return $class;
  	}
  }
	return "textfile";
}

?>