/*
 WLib Javascript Library
 Auhtor: Matthias.Wiede@web.de
 
 WPopup
 
*/

function WPopup (name, target, attr)
{
	/* Init vars */
	this.target = target;
	this.name = name;
	this.attr = attr;
	
	/* Temporary and status vars */
	this.wnd = null;
	this.content = null;	
	this.header = null;
	this.fResize = false;
	this.moveXDiff = 0;
	this.moveYDiff = 0;
	this.oldMousePos = {x:0, y:0};

	this.showPopupFilter = function () {	
		if (this.attr.is_no_modal)
			return;
		WUI.showPopupFilter ();

	}

	this.hidePopupFilter = function () {
		if (this.attr.is_no_modal)
			return;

		WUI.hidePopupFilter ();
	}
	
	this.onMouseDown = function (evt) 
	{
		var div= (evt.target) ? evt.target : evt.srcElement;
		var popup = WUI.popupList[div.parentNode.id];
		if (popup && evt.button!=2) {
			popup.captureMouse (evt);
		}		
		return false;
	}
	
	this.onMouseUp = function (evt, popup) 
	{			
		var div= (evt.target) ? evt.target : evt.srcElement;
		if (!popup)
			popup = WUI.popupList[div.parentNode.id];

		if (popup) {
			
			popup.fResize = false;
			popup.releaseMouse ();
		}		
		
		return false;
	}
	
	this.updateContentSize = function () {
		var paddingHeight = parseInt (jQuery(this.content).css ('padding-top'))  + parseInt(jQuery (this.content).css ('padding-bottom')) + 2;
		var paddingWidth  = parseInt (jQuery(this.content).css ('padding-left')) + parseInt(jQuery (this.content).css ('padding-right'))  + 2;				
		this.content.style.width  = (this.wnd.offsetWidth -paddingWidth)+'px';
		this.content.style.height = (this.wnd.offsetHeight-paddingHeight-this.header.offsetHeight)+'px';
		// Auto resize containing iframe


		jQuery('#'+this.content.id+'_iframe').height (this.wnd.offsetHeight-60);
		
	}
		
	this.onMouseMove = function (evt, popup) 
	{
		var div= (evt.target) ? evt.target : evt.srcElement;
		if (!popup)
			popup = WUI.popupList[div.parentNode.id];

		var x  = WUI.mouseCoords.x-popup.moveXDiff;
		var y  = WUI.mouseCoords.y-popup.moveYDiff;

		
		if (popup.fResize==true) {


			
			var xd = 0; 
			var yd = 0; 
			xd = WUI.mouseCoords.x-popup.oldMousePos.x;
			var newWidth = parseInt(popup.wnd.offsetWidth-2)+xd;
			if (newWidth<120) {
				newWidth=120;
				popup.oldMousePos.x = popup.oldMousePos.x-(popup.wnd.offsetWidth-2)+120;
			}
			else {
				popup.oldMousePos.x = WUI.mouseCoords.x;
			}				
			popup.wnd.style.width   = newWidth+"px";

			
			

			yd = WUI.mouseCoords.y-popup.oldMousePos.y;
			
			var newHeight = parseInt(popup.wnd.offsetHeight-2)+yd;
			if (newHeight<120) {
				newHeight=120;
				popup.oldMousePos.y = popup.oldMousePos.y-(popup.wnd.offsetHeight-2)+120;
			}
			else {
			
				popup.oldMousePos.y = WUI.mouseCoords.y;
			}
			popup.wnd.style.height  = newHeight+"px";			
		
			
			
			popup.updateContentSize ();
		}
		else {


			if (x<0) {

				x=0;
			}
			popup.wnd.style.left = x+"px";
			if (y<0) {
				y=0
			}
			popup.wnd.style.top  = y+"px";
		}

	
		return false;
	}	
	
	
	this.onMouseDown2 = function (evt) 
	{
	
		var div= (evt.target) ? evt.target : evt.srcElement;
		var popup = WUI.popupList[div.parentNode.id];

		if (popup && evt.button!=2) {

			popup.fResize = true;
			popup.captureMouse (evt);

		}		
		return false;
	}
	
	this.closePopup = function () {
		if (this.attr.close_script)
			WSystem.evalScript (this.attr.close_script)

		this.target.removeChild (this.wnd);
		delete WUI.popupList[this.name];

		if (this.attr.addClass)	{
			jQuery ('#'+this.attr.addClass[0]).removeClass (this.attr.addClass[1]);
		}
		
		this.hidePopupFilter ();

	}

	this.captureMouse  = function (evt) {

		WUI.captureMouse (this.onMouseMove, this.onMouseUp, this);
		if (this.fResize) {

			document.body.style.cursor = 'nw-resize';
			this.wnd.style.cursor = 'nw-resize';
		}
		else {
			document.body.style.cursor = 'move';
			this.wnd.style.cursor = 'move';
		}
		var pos = WSystem.getAbsoluteCoords (this.wnd);
		this.moveXDiff = WUI.mouseCoords.x - pos.x;
		this.moveYDiff = WUI.mouseCoords.y - pos.y;
		this.oldMousePos = WUI.mouseCoords;
	
		// prevent text selection		
		document.onselectstart = function () { return false; };  
		this.wnd.ondragstart = function() { return false; }; 

		/*	
		evt.stopPropagation();
		evt.preventDefault ();
	
		*/

	
		
	}

	this.releaseMouse = function () {
		WUI.releaseMouse ();
		
		// allow text selection
		document.onselectstart = null; 
		this.wnd.ondragstart = null; 
		

		document.body.style.cursor = 'default';
		this.wnd.style.cursor = 'default';

	}

	this.createPopup = function (name, target, attr)
	{
		// Set default attributes

	
		this.showPopupFilter ();

		var wnd = document.createElement('div');
		wnd.id = name;
		wnd.style.position = "absolute";
		wnd.className = 'popup_window';
		var x = WUI.mouseCoords.x;
		var y = WUI.mouseCoords.y;
		if (attr.x)
			x = attr.x;
		if (attr.y)
			y = attr.y;
			

			
		wnd.style.left = x+"px";
		wnd.style.top  = y+"px";

		if (attr.width)
			wnd.style.width = attr.width+"px";

		if (attr.height)
			wnd.style.height = attr.height+"px";
			
		
		if (attr.addClass)
			jQuery ('#'+attr.addClass[0]).addClass (attr.addClass[1]);

		// Resize element
		
		
		if (!attr.is_no_resizeable) {
			var resize = document.createElement('div');
			resize.className = 'popup_resize';
			
			WSystem.addEvent (resize, "mousedown", this.onMouseDown2);
			WSystem.addEvent (resize, "mouseup", this.onMouseUp);	
			
			wnd.appendChild (resize);
		}			
		// Header (movable)
		var header = document.createElement('div');
		header.className = 'popup_header';
	
		if (attr.is_moveable) {
	

			WSystem.addEvent (header, "mousedown", this.onMouseDown);
			WSystem.addEvent (header, "mouseup", this.onMouseUp);	
			jQuery (header).css ('cursor', 'move');
		}
		else {
			jQuery (header).css ('cursor', 'default');
		}

		if (attr.is_no_close)
			header.innerHTML = attr.topic;
		else
			header.innerHTML = attr.topic+'<a title="'+WLanguage.closeWindow+'" class="popup_close" href="#" onclick="if (WUI.popupList[\''+name+'\']) WUI.popupList[\''+name+'\'].closePopup();return false;"></a>';
		wnd.appendChild (header);
		
		// Content
		var content = document.createElement('div');
		content.className = 'popup_content';
		content.style.overflow='auto';
		content.id=name+'_content';
		content.innerHTML = attr.html;
		
		// Execute script
		WSystem.evalScript (attr.html);

		wnd.appendChild (content);	
		target.appendChild (wnd);
		
		
		// Align
		if (attr.align) {			
			switch (attr.align) {
				case 'center':	
					var scrollPos = WSystem.getScrollPos ();
					var wndDim = WSystem.getWindowDim ();
					var x0=scrollPos.x, y0=scrollPos.y, width=wndDim.windowWidth, height=wndDim.windowHeight;
					var alignBy = null;
					if (attr.align_by)
						alignBy = document.getElementById (attr.align_by);
					
					if (alignBy) {
						x0     = alignBy.offsetLeft;
						y0     = alignBy.offsetTop;
						width  = alignBy.offsetWidth;
						height = alignBy.offsetHeight;
						if (x0<0)
							x0=10;
						if (y0<0)
							y0=10;
					}
					
					var y = y0 + ((height - wnd.offsetHeight) /2);
					if (y<0)
						y=0;
					var x = x0 + ((width  - wnd.offsetWidth)  /2);
					if (x<0)
						x=0;
					
					wnd.style.left = x + 'px';
					wnd.style.top  = y + 'px';
					break;
				default:
				
					var coords = attr.align.split("x");

					x = parseInt (coords[0]);
					y = parseInt (coords[1]);
					var alignBy = null;
					if (attr.align_by)
						alignBy = document.getElementById (attr.align_by);
					
					if (alignBy) {
						x+= alignBy.offsetLeft;
						y+= alignBy.offsetTop;					
						if (x0<0)
							x=10;
						if (y0<0)
							y=10;
					}
					wnd.style.left = x + 'px';
					wnd.style.top  = y + 'px';
					break;
			}
		}
		
		this.wnd = wnd;
		this.header = header;
		this.content = content;
		
		this.updateContentSize();			
			
	}
	
	// Create popup	
	this.createPopup (name, target, attr);

	WUI.popupList[name]=this;
		
}
