/*
 WLib Javascript Library
 Auhtor: Matthias.Wiede@web.de
 
 WSplitter
 
*/

function WSplitter (id, attr)
{
	/* Init vars */
	this.id = id;
	this.splitter = null;
	this.parent = null;
	this.left = null;
	this.right = null;
	this.attr = null;
	/* Temporary and status vars */
	this.moveXDiff = 0;
	this.moveYDiff = 0;
	this.oldMousePos = {x:0, y:0};

	
	this.init = function () {
		this.loadCookies ();
	
		var newWidth = parseInt(this.left.style.width);
		if (!newWidth)
			newWidth = parseInt(this.left.offsetWidth);
		this.right.style.marginLeft   = newWidth+25+"px";
		
	}
		
		

	this.showPopupFilter = function () {	
		jQuery('#no_select_filter').hide();	
		if (WSystem.ieVersion<7) {
			var filterHeight  = jQuery(document).height()-4;
			if (filterHeight<jQuery(window).height())
				filterHeight = jQuery(window).height();
			jQuery('#no_select_filter').attr('style', 'position:absolute;left:0;top:0;display:block;width:100%;height:'+filterHeight+'px;');	
		}
		else
			jQuery('#no_select_filter').attr('style', 'position:fixed;left:0;top:0;display:block;width:100%;height:100%;');	

		jQuery('#no_select_filter').show();
	}

	this.hidePopupFilter = function () {

		jQuery('#no_select_filter').hide();	
	}
			
		
	this.onMouseMove = function (evt, splitter) 
	{

		var div= (evt.target) ? evt.target : evt.srcElement;
		if (!splitter)
			splitter = WUI.splitterList[div.id];

		var x  = WUI.mouseCoords.x-splitter.moveXDiff;
		var y  = WUI.mouseCoords.y-splitter.moveYDiff;
				
		var xd = 0; 
		var yd = 0; 
		xd = WUI.mouseCoords.x-splitter.oldMousePos.x;
		var newWidth = parseInt(splitter.left.offsetWidth)+xd;
		if (newWidth<120) {
			newWidth=120;
			splitter.oldMousePos.x = splitter.oldMousePos.x-(splitter.left.offsetWidth)+120;
		}
		else {
			splitter.oldMousePos.x = WUI.mouseCoords.x;
		}	
		splitter.left.style.width   = newWidth+"px";
		splitter.right.style.marginLeft   = newWidth+25+"px";
		
		
/*
		yd = WUI.mouseCoords.y-splitter.oldMousePos.y;
		
		var newHeight = parseInt(splitter.left.offsetHeight-2)+yd;
		if (newHeight<120) {
			newHeight=120;
			splitter.oldMousePos.y = splitter.oldMousePos.y-(splitter.wnd.offsetHeight-2)+120;
		}
		else {
		
			splitter.oldMousePos.y = WUI.mouseCoords.y;
		}
		splitter.left.style.height  = newHeight+"px";			
	
		*/
	
		return false;
	}	
	
	
	this.onMouseDown = function (evt) 
	{

		var div= (evt.target) ? evt.target : evt.srcElement;
		var splitter = WUI.splitterList[div.id];

		if (splitter && evt.button!=2) {

			splitter.captureMouse (evt);

		}		
		return false;
	}
	
	this.onMouseUp = function (evt, splitter) 
	{			
		var div= (evt.target) ? evt.target : evt.srcElement;
		if (!splitter)
			splitter = WUI.splitterList[div.id];

		if (splitter) {
			
			splitter.releaseMouse ();
		}		
		
		return false;
	}
	
	this.captureMouse  = function (evt) {
		this.showPopupFilter ();
		WUI.captureMouse (this.onMouseMove, this.onMouseUp, this);

		document.body.style.cursor = 'e-resize';
		this.parent.style.cursor = 'e-resize';
	
		var pos = WSystem.getAbsoluteCoords (this.splitter);
		this.moveXDiff = WUI.mouseCoords.x - pos.x;
		this.moveYDiff = WUI.mouseCoords.y - pos.y;
		this.oldMousePos = WUI.mouseCoords;
	
		// prevent text selection		
		jQuery(this.parent).css({"user-select": "none", "-webkit-user-select": "none", "-khtml-user-select": "none", "-moz-user-select": "none"});
		document.onselectstart = function () { return false; };  
		this.parent.ondragstart = function() { return false; }; 
		this.left.ondragstart = function() { return false; }; 
		this.right.ondragstart = function() { return false; };
		
		
		 
	}

	this.releaseMouse = function () {
		this.hidePopupFilter ();
		WUI.releaseMouse ();
		
		// allow text selection
		jQuery(this.parent).css({"user-select": "text", "-webkit-user-select": "text", "-khtml-user-select": "text", "-moz-user-select": "text"});
		document.onselectstart = null; 
		this.parent.ondragstart = null; 
		this.left.ondragstart = null; 		
		this.right.ondragstart = null; 
		
		document.body.style.cursor = 'default';
		this.parent.style.cursor = 'default';
		
		WUI.onWindowResize ();
		this.saveCookies ();
	}
	
	this.loadCookies = function () {
		if (jQuery.cookie('wsystem_'+this.id+'_left')) {	  
			this.left.style.width = parseInt (jQuery.cookie('wsystem_'+this.id+'_left'))+'px';
	
		}
	}
		
	this.saveCookies = function  () {
		jQuery.cookie('wsystem_'+this.id+'_left', parseInt(this.left.style.width), {path:'/'});
	}

	this.createSplitter = function (id, attr)
	{
		this.id = id;
		this.splitter = document.getElementById (id);		
		this.parent = jQuery (this.splitter).parent()[0];
		this.left = jQuery (this.splitter).prev()[0];
		this.right = jQuery (this.splitter).next()[0];
		this.attr = attr;
		WSystem.addEvent (this.splitter, "mousedown", this.onMouseDown);
		WSystem.addEvent (this.splitter, "mouseup", this.onMouseUp);			
		this.init();		
	}

	this.createSplitter (id, attr);
	WUI.splitterList[id]=this;

}
