/*
 WLib Javascript Library
 Auhtor: Matthias.Wiede@web.de
 
 WGUI
 
*/

// Helper: Checker for CKEditor
function CKEditorCheck (i, data) {
	this.i = i;
	this.data = data;
	this.checkModification = function () {			
		try {
			var data2 = CKEDITOR.instances[this.i].dataProcessor.toHtml( CKEDITOR.instances[this.i].getData ());
			if (data2!=null && $.trim (data2)!=$.trim (this.data)) {
				// WUI.ckEditorCheckList[this.i].data=data2;
				WSystem.fModified=true;
				return true;
			}
		}
		catch (e) {
		}
		return false;
	}
}

WUI = {
	fSystemContextMenu : true,
	fIgnoreMouseDown : false,
	releaseContextMenuFunc : null,
	mouseMoveFunc : null,
	mouseUpFunc : null,
	mouseCaptureParam : null,
	mouseCoords : {x: 0, y: 0 },
	oldMouseCoords : {x:0, y:0},
	contextMenuCoords : {x:0, y:0},
	menuList : Array (),
	popupList : Array (),
	splitterList : Array (),
	dragableList : Array (),
	ckEditorCheckList: Array (),
	oldRequest : { },
	resizeList : Array (),
	currentAjaxRequest : null,
	sessionLogFilename : null,
	currentCalendarField : '',
	calendarScript : '../wlib/php/utils/calendar/calendar.php',
	updateTimedData : { url: '', id : ''},
	videoPlayer : null,
	timer: null,
	ownResizeFunc : null,
	ownMouseDownFunc : null,
	currentDropDownBox : '',
	dropDownBoxVal : null,
	
	toggleTreeview : function (id, fBottom, updateURI) {
		var obj = document.getElementById ('wrap_'+id);
		var img = document.getElementById ('toggle-img-'+id);
		var parents = id.split ("-");

		img.style.cursor = 'wait';
		if (obj.innerHTML!='') {

			WUI.ajaxRequest (updateURI+'&'+parents[0]+'_cmd=close', 'wrap_'+id,
				function () { 
					if (fBottom)
						img.src="images/tree/plusbottom.gif";
					else
						img.src="images/tree/plus.gif";		
					img.style.cursor = 'pointer'; 
				}, true
			);

		}
		else {
			WUI.ajaxRequest (updateURI+'&'+parents[0]+'_cmd=open', 'wrap_'+id, 
				function () { 
					if (fBottom)
						img.src="images/tree/minusbottom.gif";
					else
						img.src="images/tree/minus.gif";
					img.style.cursor = 'pointer'; 
				}, true
			);
		}
	},
	
	/* Create Javascript menu array from <ul> menu structure */
	createMenuItemsFromULStruct : function (obj) {
		var pos = 0;
		var items = new Array ();
		if (obj) {
			obj = obj.firstChild;
			while (obj) {
				if (obj.nodeName=='LI') {
					var linkObj = obj.firstChild;
					if (linkObj && linkObj.nodeName=='A') {					
						var text   = linkObj.innerHTML;
						// Replace html entities
						text = text.replace ("&amp;", "&");
						var linkURL    = linkObj.href;
						items[pos] = new Array (text, linkURL, "", linkObj);
						var subObj = linkObj.nextSibling; // UL node
						if (subObj && subObj.nodeName=='UL') {
							items[pos][2] = WUI.createMenuItemsFromULStruct (subObj);
						}				
						pos++;
					}
				}
				obj = obj.nextSibling;
			}
		}
		return items;
	},
	
	showMessage : function (text, type, fPopup, formId) {
		if ($.trim (text)=='')
			return;
			
		if (fPopup) {
			WUI.openPopup ('exceptionPopup', 
			{ width : 600, 
			  height : 300, 
				topic : type.toUpperCase (),
				html : text,
				is_no_modal : 1,
				is_moveable : 1}
			)
			return;		
		}
		var name = 'msgText';
		if (formId)
			name = formId+' .msgText';		
		if (!$ ('#'+name).length) {
			name = 'msgText';
			
			if (!document.getElementById (name)) {
				var page = document.getElementById ('wrap_page');
				if (!page) {
					document.body.innerHTML = '<div id="msgText"></div>';
				}
				else {			
					page.innerHTML = '<div id="msgText"></div>';			
				}
			}
		}		

		$ ('#'+name).css ("opacity", "0");//hide ();
		$ ('#'+name).
			removeClass().
			addClass ('msgText').
			addClass (type).
			html (text).
			fadeTo('1300', 1, function() {});		

	},
	
	handleErrorResponse : function (formId, xhr, status, url) {
		// Enable submit button
			
		$('#'+formId+' .submit').removeAttr("disabled");
		if (xhr.statusText!='abort') {
	
			WUI.showMessage ('HTTP-Error: '+xhr.status+' / '+xhr.statusText+'<br />'+url, "warning");
		}
	},
	
	
	setParentSubmitLocked : function (formId) {
		
		WSystem.fModified = true;
		if (!formId || formId=='empty')
			return;

		$('input.button:submit').not('#'+formId+' input.button:submit').bind ('click', function (evt) {
				if (WSystem.fModified) {
					if (!$(evt.target).attr("disabled")) {
						alert (WLanguage.saveSubFormular);
						$(evt.target).attr("disabled", true);						
					}
					return false;
				}
		});
	},

	handleDefaultResponse : function (formId, data, status, xhr)  {
		data = $.trim (data);

		WUI.stopUpdateTimed ();

		// Check Json content type
		var contentType = xhr.getResponseHeader ("Content-Type");				

/*
		if (contentType!='text/plain') {
			// Enable submit button
			$('#'+formId+' input.button').removeAttr("disabled");			
			WUI.showMessage (data, 'error', true);
			return null;
		}
*/
		// Parse Json data
		var json = null;
		try
		{
			json = $.parseJSON (data);
		}
		catch(e) {
			$('#'+formId+' input.button').removeAttr("disabled");		
			if (data && data!='') {
				WUI.showMessage (data, 'error', true);
			}
			return null;
		} 

		// Check unsaved modification
		if (json.checkUnsavedModification!==null) {

			switch (json.checkUnsavedModification) 
			{
				case 1:
					WSystem.fModified = false;
					if(window.CKEDITOR) {
						for ( var i in CKEDITOR.instances ){
							if (i in WUI.ckEditorCheckList) {
								try {
									var html = CKEDITOR.instances[i].dataProcessor.toHtml( CKEDITOR.instances[i].getData ());
									WUI.ckEditorCheckList[i].data = html;
								}
								catch (e) {
								}
							}
						}
					}
					break;
			}
		}
	
					
		// Enable submit button	
		$ ('#'+formId+' input.button').removeAttr("disabled").unbind ("click");
		
		if (json.freePageInstances!==null && json.freePageInstances) {

			WUI.freePageInstances (json.freePageInstances);
		}

		// Show question
		if ((json.question!==null && json.question.text!='') ||  (json.retry!==null && json.retry)) {
			if (json.retry || confirm (json.question.text)) {
				WUI.ajaxRequest (
					WUI.oldRequest.requestURL, 
					WUI.oldRequest.formId, 
					WUI.oldRequest.returnFunc, 
					WUI.oldRequest.fNoCheck,
					json.retry ? WUI.oldRequest.postData : (WUI.oldRequest.postData ? WUI.oldRequest.postData+='&is_confirm=1' : 'is_confirm=1'));
					
			}
			else {
				return null;
			}
		}

		if (json.closePopupId!==null && json.closePopupId) {
			WUI.closePopup (json.closePopupId);
		}

		if (json.removeDragableId!==null && json.removeDragableId) {
			WUI.removeDragable (json.removeDragableId);
		}
		
		// Redirect
		if (json.redirectURI!==null && json.redirectURI) {
			// WUI.ajaxRequest (json.redirectURI, "wrap_page", null, false, json.postData);
			WUI.loadPage (json.redirectURI, json.postData, '', '', true);
			return null;
		}

		
		if (json.message!==null && json.message && json.message.text!='') {
			// Show message
			WUI.showMessage (
				json.message.text, 
				json.message.type,
				false,
				formId);	
		}

			
		// Show areas
		if (json.updateAreas!==null && json.updateAreas) {
			for (var areaId in json.updateAreas) {
				if (areaId=='wrap_page')
					WUI.resizeList = Array ();
				$ ('#'+areaId).html (json.updateAreas[areaId]);	
				
			}
		}
		
		if (areaId=='wrap_page')
			WUI.onWindowResize ();
		
		// Check modification events
		if (json.checkUnsavedModification!==null && json.checkUnsavedModification) {
			
			switch (json.checkUnsavedModification) 
			{				
				case 2:
					WSystem.fModified = false;
					var prefix = '#'+formId+' ';
					if (formId=='empty')
						prefix = '';
					$(prefix+'form input').change (function(event) {
						WUI.setParentSubmitLocked (formId);
					});
					$(prefix+'form textarea').change(function(event) {
						WUI.setParentSubmitLocked (formId);
					});	
					$(prefix+'form select').change(function(event) {
						WUI.setParentSubmitLocked (formId);
					});
					break;
			}
		}
		
		// Individual script
		if (json.evalScript!==null && json.evalScript) {
			WSystem.evalScript (json.evalScript);
		}

		if (json.hideId!==null && json.hideId) {
			// Hide area
			$('#'+json.hideId).hide ();
		}
		
		// Show popups
		if (json.popups!==null && json.popups) {
			for (var popupId in json.popups) {
				WUI.openPopup (popupId, json.popups[popupId]);
			}
			return json;
		}

		
		// Hide mesage text only if no 'done' mode
		if (WUI.oldRequest.postData!='view=done') { 
			if (!json.message || json.message.text=='')
			{
				var name = formId+' .msgText';		
				if (!$ ('#'+name).length)		
					name = 'msgText'
				$ ('#'+name).hide ();
			}
			
			// Remove all errors images
			$ ('#'+formId+' .input_error_img').remove ();
		}
		
		// Download
		if (json.downloadURI!==null && json.downloadURI) {
			// window.open(json.downloadURI);
			window.location.href=json.downloadURI;

		}
		return json;
	},


	ajaxRequest : function (requestURL, formId, returnFunc, fNoCheck, postData, fNoProgress) {
		if (!fNoCheck && WUI.checkModification (true))
			return;


		WUI.oldRequest = { 
			requestURL : requestURL, 
			formId : formId, 
			returnFunc : returnFunc, 
			fNoCheck : fNoCheck,
			postData : postData };
		
		/*
		// Old stuff!
		if (formId=='wrap_page' && !fNoHistory) {
			top.frames["historyFrame"].location.href = "history_frame.php?uri="+escape (requestURL)+"&postData="+escape (postData);
			return;
		}
		*/
		if (!fNoProgress) {
			$ ('#page_progress').show ();		
			$('#'+formId+' input.button').attr("disabled", true);
		}
		
		WUI.currentAjaxRequest = $.ajax({ 
			type: "POST",
			url: requestURL,
			/* headers: { 'Connection' : 'close' },  IE7 bug */
			data: postData,
			async: true,
			error : function (xhr, status) {
				$ ('#page_progress').hide ();
				WUI.handleErrorResponse (formId, xhr, status, requestURL);
			},
			success: function(data, status, xhr) {

				$ ('#page_progress').hide ();
				if ((json=WUI.handleDefaultResponse (formId, data, status, xhr))) {
					if (returnFunc)
						returnFunc (data);
					if (json.fields) {					
						WUI.showFormFields (formId, json.fields);
					}
				}
		}});
	},
	
	ajaxUpdate : function (requestURL, id, fShowError) {
		if (!document.getElementById(id))
			return;
		$.ajax({ 
			type: "POST",
			url: requestURL,
			data: '',
			async: true,
			error : function (xhr, status) {
				if (fShowError) {
					$ ('#page_progress').hide ();
					WUI.handleErrorResponse (id, xhr, status, requestURL);
				}
			},
			success: function(data, status, xhr) {
				$ ('#'+id).show ().html (data);
		}});
	
	},
	
	ajaxUpdateTimed : function (requestURL, id, updateTime) {
		if (!document.getElementById(id))
			return;
		WUI.updateTimedData = { url: requestURL, id : id};
		if (WUI.timer) {
			clearInterval (WUI.timer);
			WUI.timer=null;
		}
		WUI.ajaxUpdate (requestURL, id);
		WUI.timer = setInterval( function () {
			WUI.ajaxUpdate (requestURL, id);
			 }, updateTime);			
	},
	
	stopUpdateTimed : function () {
		if (WUI.timer) {			
			clearInterval (WUI.timer);
			WUI.timer=null;
			WUI.ajaxUpdate (WUI.updateTimedData.url, WUI.updateTimedData.id);
		}		
	},		
			
	ajaxRequestConfirm : function (requestURL, confirmText, formId, fNoCheck, postData, fNoProgress) {
		if (!fNoCheck && WUI.checkModification (true))
			return;
	
		if (confirm (confirmText))
			WUI.ajaxRequest (requestURL, formId, null, fNoCheck, postData, fNoProgress);
	},
	
	showFormFields : function (formId, fields) {

		for (var name in fields) {
			var wrap = $('#'+formId+' #'+name+':first');

			if (wrap.length==0) {
				continue;
			}

			// Set value
		 	var value = fields[name].valf;		 	
			// var ctrl = $('#'+formId+' > #'+name+'_ctrl');
			
			var ctrl = $('#'+wrap[0].id+' > #'+name+'_ctrl');
			// alert (name+" wrap.id="+wrap[0].id+" / "+ctrl.attr('type'));
			
			var fHidden = false;
			switch (ctrl.prop('tagName')) {
				case 'INPUT':
					switch (ctrl.attr('type')) {
						case 'checkbox':
							if (value==1)
								ctrl.attr('checked', 'checked')
							break;
						case 'hidden':
							fHidden = true;
							// Check if upload dialog
							var wrap2 = $('#'+formId+' #'+name+'_fullview_link');
							if (wrap2.length!=0 && value=='') {
/*
								wrap2.hide ();
							  $('#'+formId+' #'+name+'_upload_frame .qq-upload-success').hide ();
								$('#'+formId+' #'+name+'_tmp_ctrl').val (value);
								$('#'+formId+' #'+name+'_tmp_orig_ctrl').val (value);
*/
							} 
							else
							if (wrap2.length!=0) {
							
								var tmp  = wrap2[0].href;
								var tmp2 = $('#'+formId+' #'+name+'_path_ctrl').val()+'/'+value;
								var tmp3 = $('#'+formId+' #'+name+'_tmp_ctrl').val();
								var tmp4 = $('#'+formId+' #'+name+'_path_ctrl').val()+'/'+$('#'+formId+' #'+name+'_ctrl').val();

								var rep  = tmp3;																
								if (tmp3!='') {
									wrap2[0].href = tmp.replace (tmp3, tmp2);
								}
								else {
									wrap2[0].href = tmp.replace (tmp4, tmp2);
									rep = tmp4;
								}				
								var src= $('#'+formId+' #'+name+'_preview_img').attr ('src');
								src=src.replace (rep,tmp2);
								$('#'+formId+' #'+name+'_preview_img').attr ('src', src);
												
								if (document.getElementById (name+'_direct_link')) {
									src= $('#'+formId+' #'+name+'_direct_link').attr ('href');
									src=src.replace (rep,tmp2);
									$('#'+formId+' #'+name+'_direct_link').attr ('href', src);													
								}

							}
						
						case 'text':
							ctrl.val (value);
							break;
						case 'password':
							ctrl.val (value);
							break;
					};							
					break;
				case 'SELECT':
					ctrl.val(value).attr("selected", "selected");
					break;
			}
			// Mark field
			if (fields[name].isError || fields[name].isMandatory) 
			{
				wrap.addClass ("input_error");
				wrap.css ("opacity", 0);
							
				// Error tooltip
				$('<div title="'+fields[name].errText+'" class="input_error_img"><img width="19" height="21" src="images/s_warn.png" alt="" /></div>').
					insertAfter('#'+formId+' #'+name+':first').
					tooltip({showURL: false});
			}
			else {
				wrap.removeClass ("input_error");
			}
			wrap = ctrl = null;
		}
		// Fade in all input errors
		$('#'+formId+' .input_error').fadeTo('1300', 1, function() {});
	},
	
	submitFormConfirm : function (formId, submitURL, confirmText) {
		if (confirm (confirmText)) {
			WUI.submitForm (formId, submitURL);
			$('input:submit').removeAttr("disabled");
		}
	},

	submitForm : function (formId, submitURL) {

		$('#'+formId+' input.button').attr("disabled", true);
		$ ('#page_progress').show ();
		
		// Get instances of CKEDITOR
		if(window.CKEDITOR) {
			for ( var i in CKEDITOR.instances ){
			   var name = CKEDITOR.instances[i].name;
			  $('#'+name).val (CKEDITOR.instances[i].getData());
			}
		}
		// Get instances of TinyMCE
		if (tinyMCE) {
			for (var i in tinyMCE.editors) {	
				if (i!='indexOf') // IE shit
				 	$('#'+i).val (tinyMCE.editors[i].getContent ());
			}
		}
		
		if (WUI.sessionLogFilename)
			WUI.ajaxUpdateTimed (WUI.sessionLogFilename, 'wrap_log', 200);
		

	  $.ajax({ 
			type: "POST", 
			url: submitURL, 
			data: $('#'+formId).serialize(), 
			error : function (xhr, status) {
				WUI.handleErrorResponse (formId, xhr, status, submitURL);	
				
			},
			success: function(data, status, xhr) {
				$ ('#page_progress').hide ();

				var json = null;
				if ((json=WUI.handleDefaultResponse (formId, data, status, xhr))) {
					if (json.fields ) {

						WUI.showFormFields (formId, json.fields);		
					}
				}
		}});
	  return false;
	},
	
	freePageInstances : function (freeIdx) {
		// Delete all instances of CKEDITOR
		if(window.CKEDITOR) {
			for ( var i in CKEDITOR.instances ){
				if (freeIdx!=1 && freeIdx && i!=freeIdx) {
					continue;
				}
				
				if (i in WUI.ckEditorCheckList) {
					delete WUI.ckEditorCheckList[i];
					WUI.ckEditorCheckList.splice (i,1);
				}
				delete CKEDITOR.instances[i]; 

			}
		}
		// Delete all instances of tinyMCE				
		if (tinyMCE) {
			for (var i in tinyMCE.editors) {
				if (freeIdx!=1 && freeIdx && i!=freeIdx) {
					continue;
				}
				$('#'+tinyMCE.editors[i].id).parent().hide ();
				tinyMCE.execCommand('mceRemoveControl', false, i);
			}		
		}
	},
	
	checkModification : function (fQuestion) {
		if(window.CKEDITOR) {
			for ( var i in CKEDITOR.instances ){
				if (i in WUI.ckEditorCheckList) {
					WUI.ckEditorCheckList[i].checkModification ();
				}
				else {
					return 2; // Not loaded!
				}
			}
		}
		
		if (WSystem.fModified) {
			if (fQuestion) {
				if (!confirm (WLanguage.somethingWasModified))	{

					$ ('#page_progress').hide ();
					return 1;
				}
				$('input:submit').removeAttr("disabled").unbind ("click");
				WSystem.fModified=false;
			}
			else {

				return 1;
			}
		}
		return 0;
	},
	
	windowBeforeUnload : function (e) {	
	
		if(window.CKEDITOR) {
			for ( var i in CKEDITOR.instances ){
				if (i in WUI.ckEditorCheckList) {
					WUI.ckEditorCheckList[i].checkModification ();
				}
			}
		}
		if (WSystem.fModified) { 
			var e = e || window.event;
      e.returnValue = WLanguage.somethingWasModified;		
			return WLanguage.somethingWasModified;
		}
	},
		
  loadPage : function (uri, postData, uri2, postData2, fNoFreeInstances) {
		if (WUI.checkModification (true))
			return false;
			
		WUI.stopUpdateTimed ();
		
		if (WUI.currentAjaxRequest && WUI.currentAjaxRequest.readyState != 4) {
			WUI.currentAjaxRequest.abort();
		}

  	var wrap = document.getElementById ("wrap_page");
  	if (wrap) {
			WUI.closePopup ('popup_calendar');
			if (uri2) {
				if (uri2.indexOf ('page_is_ajax=1')==-1)
					uri2+='&page_is_ajax=1';
				WUI.ajaxRequest (uri2, "wrap_page", function () { 

					if (!fNoFreeInstances)
						WUI.freePageInstances();
					$ ('#page_progress').show ();
					if (uri.indexOf ('page_is_ajax=1')==-1)
						uri+='&page_is_ajax=1';		
						
					if (WUI.sessionLogFilename)
						WUI.ajaxUpdateTimed (WUI.sessionLogFilename, 'wrap_log', 200);
						
					WUI.ajaxRequest (uri, "wrap_page", null, true, postData);
					
				
				}, true, postData2);
				
			}
			else
			{							
				
				if (!fNoFreeInstances)
					WUI.freePageInstances();	
				$ ('#page_progress').show ();
				if (uri.indexOf ('page_is_ajax=1')==-1)
					uri+='&page_is_ajax=1';		

				if (WUI.sessionLogFilename)
					WUI.ajaxUpdateTimed (WUI.sessionLogFilename, 'wrap_log', 200);
				WUI.ajaxRequest (uri, "wrap_page", null, true, postData);
			}
		}
		else
			window.location.href=uri;
			

		return true;
	},
	
	disableSystemContextMenu : function () {
		WUI.fSystemContextMenu = false;
	},
	
	enableSystemContextMenu : function () {
		WUI.fSystemContextMenu = true;
	},
	
	openContextMenu : function (menuItems, coords, releaseFunc) {
		if (WUI.fIgnoreMouseDown)
			return;
		WUI.closeContextMenu ();
		WUI.contextMenuCoords = coords;
		WUI.releaseContextMenuFunc = releaseFunc;
		var menu = new WMenu ("contextmenu", document.body, coords.x, coords.y, menuItems, false);
		WUI.fIgnoreMouseDown=true;
		WUI.disableSystemContextMenu ();
	},
	
	closeContextMenu : function () {

		if (WUI.menuList["contextmenu"]) {
			WUI.menuList["contextmenu"].closeMenu ();
			WUI.menuList["contextmenu"] = null;
			if (WUI.releaseContextMenuFunc) {
				WUI.releaseContextMenuFunc ();
				WUI.releaseContextMenuFunc = null;
			}
		}
	},
	
	openPopup : function (name, attr) {
		if (!WUI.popupList[name]) {
			new WPopup (name, document.body, attr);
			if (!attr.is_no_focus)
				$('#'+name+' input:visible:enabled:first').focus();
		}
	},
	
	closePopup : function (name) {
		if (WUI.popupList[name])
			WUI.popupList[name].closePopup ();
	},
	
	captureMouse : function (mouseMoveFunc, mouseUpFunc, param) {
		WUI.mouseMoveFunc = mouseMoveFunc;
		WUI.mouseUpFunc = mouseUpFunc;
		WUI.mouseCaptureParam = param;

		if (document.body.releaseCapture)
			document.body.setCapture();
		
	},
	
	removeDragable : function (name) {
		for (dragableId in WUI.dragableList) {				
			var tmp = name;
			tmp = tmp.replace("*", "[a-zA-Z0-9_]");
			rexp = new RegExp(tmp);
			if (dragableId.search (rexp)!=-1) {				
				WUI.dragableList[dragableId].remove ();
			}
		}
	},
	
	releaseMouse : function () {
		WUI.mouseMoveFunc = null;
		WUI.mouseUpFunc = null;

		if (document.body.releaseCapture)
			document.body.releaseCapture();
	},
	
 	onDocumentMouseDown : function (evt) {
		if (WUI.ownMouseDownFunc)
			eval (WUI.ownMouseDownFunc);

		if (WUI.fIgnoreMouseDown) {
			WUI.fIgnoreMouseDown=false;
			return true;
		}


		WUI.closeContextMenu ();
		WUI.enableSystemContextMenu ();
	
		if (WUI.currentDropDownBox!='') {
			var offset = 	$(WUI.currentDropDownBox).offset();
			var width = 	$(WUI.currentDropDownBox).width()  + parseInt ($(WUI.currentDropDownBox).css("padding-left")) * 2;
			var height = 	$(WUI.currentDropDownBox).height() + parseInt ($(WUI.currentDropDownBox).css("padding-top"))  * 2;
			var fIn = (WUI.mouseCoords.x>=offset.left) && (WUI.mouseCoords.x<=offset.left+width) && (WUI.mouseCoords.y>=offset.top) && (WUI.mouseCoords.y<=offset.top+height);
			if (!fIn) {
				$(WUI.currentDropDownBox).remove ();
				WUI.currentDropDownBox = '';

			}
		}
	
	},
	
	onDocumentMouseMove : function (evt) {
		var fRet = false;
		WUI.mouseCoords = WSystem.getMouseCoords (evt);
		if (WUI.mouseMoveFunc) {
			fRet = WUI.mouseMoveFunc (evt, WUI.mouseCaptureParam);
		}
		WUI.oldMouseCoords = WUI.mouseCoords;
	},
	
	onDocumentMouseUp : function (evt) {
		var fRet = false;
		if (WUI.mouseUpFunc) {
			fRet = WUI.mouseUpFunc (evt, WUI.mouseCaptureParam);			
		}					
	},
	
	resize : function (name, attr) {
		var h = 0, w = 0;
		var check = name.split ("ckeditor_");
		var fCKEditor = check.length==2;
		var check2 = name.split ("tinymce_");
		var fTinyMCE = check2.length==2;
		var check3 = name.split ("textarea_");
		var fTextarea = check3.length==2;		
		
		if (attr.target=='window') {
			h = parseInt ($(window).height());
			w = parseInt ($(window).width());
		}
		else {
			var overflow = '';
			if (fCKEditor) {
				overflow = $(attr.target).css ('overflow');
				$(attr.target).css ({ 'overflow' : 'hidden' });
			}
			
			h = parseInt ($(attr.target).height());
			w = parseInt ($(attr.target).width());
			if (fCKEditor) {
				$(attr.target).css ({ 'overflow' : overflow });
			}
		}
		
		if (fTextarea) {

			$('#'+check3[1]).css ({'width' : (w+attr.corrX)+'px', 'height' : (h+attr.offsetY+attr.corrY)+'px'});	
		
		}
		else
		if (fTinyMCE && tinyMCE) {

			var id = check2[1];
			if (tinyMCE.editors[id]) {
				var o = tinymce.editors[id];
				var iframe = o.contentAreaContainer.getElementsByTagName("iframe")[0];				
				iframe.style.height = (h+attr.offsetY-135)+'px';	
				iframe.style.width = (w-6)+'px';	
			}
	
		}
		else		
		if (fCKEditor) {
			var id = check[1];

			if (CKEDITOR.instances[id]) {
						
				if (WUI.ckEditorCheckList[id]) {
					try {
						CKEDITOR.instances[id].resize (w-4, h+attr.offsetY);	
					}
					catch (all) {
					}
			
				}
				/*
				else {
					
					setTimeout ("WUI.onWindowResize (\'ckeditor\')", 100);
				}	
				*/			
			}			
		}
		else	{	
			
			h = h+attr.offsetY;
			// screen.width<=480 means Mobile, dont set min height
			if (screen.width>480 && attr.minHeight && h<attr.minHeight)
				h = attr.minHeight;
				
			// dont enhance more than screen height
			if (h>screen.height)
				h=screen.height;
			$(name).css ({'height' : h+"px"});	
			
		}		
	},
	
	onWindowResize : function (only) {
		var tmp = WUI.resizeList;
		tmp.reverse ();
		for (name in tmp)  {
			if (only && only!='' && name.indexOf(only,0)!=0)
				continue;
			WUI.resize (name, tmp[name]);
		}
		if (this.ownResizeFunc)
			eval (this.ownResizeFunc);
	},
	
	setResize  : function (name, attr, corrX, corrY) {
		attr.corrX = 0;
		attr.corrY = 0;
		if (corrX)
			attr.corrX=corrX;
		if (corrY)
			attr.corrY=corrY;
		if (!attr.prio)
			attr.prio=0;
		if (WUI.resizeList[name] && attr.prio<WUI.resizeList[name].prio) {
			 // Resize rule with highest prio
			WUI.resize (name, WUI.resizeList[name]);
			return;			
		}
		WUI.resizeList[name] = attr;


	},
	
	closeMediaPlayer : function () {
		if (WUI.videoPlayer) { 
			WUI.videoPlayer.pause (); 
			WUI.videoPlayer=null; 
		};
		WUI.closePopup('popup_mediaplayer');
	},
	
	createMediaPlayer : function (url, fQuicktime, fEdit) {
	
		var filename = WSystem.getURLParam ('f', url);
		
		
		if (filename!='') {
			var ext = /[^.]+$/.exec(filename);
			var basename = filename.replace(/^.*[\\\/]/, '');
			if (filename==basename)
				filename=filename2='../tmp/upload/'+basename;
			else			
				filename2='../'+filename;
			// var filename2 = window.location.protocol+"//"+document.domain+"/"+filename;
			ext = (ext + '').toLowerCase();
			var id = 'player';
			if (ext=="mp3") {
				WUI.openPopup ('popup_mediaplayer', { is_no_close: 1, is_no_modal: 0, width : 300,  height : 200,  topic : 'Audio Player', html : '<div style="text-align:center;"><div style="margin-bottom:10px;" id="'+id+'"></div><div><a href="'+url+'" target="_blank">'+basename+'</a><br /><input onclick="WUI.closeMediaPlayer ();" id="upload_cancel_button" value="'+WLanguage.close+'" class="button delete_button" type="button"  /></div></div>', align : 'center', is_moveable : 1 } );
				var isHTML5 = !!document.createElement('audio').canPlayType;
				var isMP3 = false;
				if (isHTML5) {
					isMP3 = !!document.createElement("audio").canPlayType("audio/mp3");
				}
				var s = new SWFObject('../wlib/js/emff/emff_lila.swf', id, 200, 70, "7", "#271F14");
				var isFlash = (s && s.installedVer && s.installedVer.major);
				if (isFlash) {					
					s.addParam("FlashVars", "src="+filename2+"&amp;autostart=yes");
					s.write (id);			
				}
				else
				if (isMP3) {
					$('#'+id).html ('<audio controls="controls" autoplay="autoplay"><source src="'+filename2+'" type="audio/mp3" />Your browser does not support the audio tag.</audio>');
				}
				return true;
			}
			else
			if (ext=="swf") {
				WUI.openPopup ('popup_mediaplayer', { is_no_close: 1, is_no_modal: 0, width : 661,  height : 600,  topic : 'SWF Player', html : '<div style="text-align:center;"><div id="'+id+'"  style="margin-bottom:10px;"></div><div><a href="'+url+'" target="_blank">'+basename+'</a><br /><input onclick="WUI.closeMediaPlayer ();" id="upload_cancel_button" value="'+WLanguage.close+'" class="button delete_button" type="button"  /></div></div>', align : 'center', is_moveable : 1 } );

				var width = 640;
				var height = 480;
				var htmlSWF = '<object width="'+width+'" height="'+height+'"><param name="movie" value="'+filename2+'"><embed src="'+filename2+'" width="'+width+'" height="'+height+'"></embed></object>';
				$('#'+id).html (htmlSWF);
				
				return true;			
			}
			else
			if (ext=="mp4" || ext=="mov") {
				var type = 'mp4';
				if (!fQuicktime)
					var extraTag = ' <input type="button" class="button default_button" onclick="WUI.closeMediaPlayer ();WUI.createMediaPlayer (\''+url+'\',true);" value="Quicktime Player" />';
				else
					var extraTag = ' <input type="button" class="button default_button" onclick="WUI.closeMediaPlayer ();WUI.createMediaPlayer (\''+url+'\');" value="Flash/HTML5 Player" />';
				
				WUI.openPopup ('popup_mediaplayer', { is_no_close: 1, is_no_modal: 0, width : 661,  height : 600,  topic : 'Movie Player', html : '<div style="text-align:center;"><div id="'+id+'"  style="margin-bottom:10px;"></div><div><a href="'+url+'" target="_blank">'+basename+'</a><br /><input onclick="WUI.closeMediaPlayer ();" id="upload_cancel_button" value="'+WLanguage.close+'" class="button delete_button" type="button"  />'+extraTag+'</div></div>', align : 'center', is_moveable : 1 } );			
				var d = new Date();
				var n = d.getTime(); 
				var options = 'controls';
				var width = 640;
				var height = 480;
				
				
				var isHTML5 = !!document.createElement('video').canPlayType;
				var isMP4 = false;
				if (isHTML5) {
					isMP4 = !!document.createElement("video").canPlayType("video/mp4");
				}

				if (fQuicktime) {
					// filename2 = '/'+filename;
					var htmlQuicktime =  '<OBJECT CLASSID="clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B" CODEBASE="http://www.apple.com/qtactivex/qtplugin.cab" WIDTH="'+width+'" HEIGHT="'+height+'" ><PARAM NAME="src" VALUE="'+filename2+'" ><PARAM NAME="autoplay" VALUE="true" ><EMBED SRC="'+filename2+'" TYPE="image/x-macpaint" PLUGINSPAGE="http://www.apple.com/quicktime/download" WIDTH="'+width+'" HEIGHT="'+height+'" AUTOPLAY="true"></EMBED></OBJECT>';
					$('#'+id).html (htmlQuicktime);
				}
				else {

					$('#'+id).html ('<video id="'+id+'_'+n+'html5" '+options+' class="video-js vjs-default-skin" preload="auto" autoplay="autoplay" width="'+width+'" height="'+height+'" data-setup="{}"><source src="'+(url+"&stream=1")+'" type="video/'+type+'"></video>');		
					_V_(id+"_"+n+"html5").ready(function() {
							WUI.videoPlayer = this;
					});				
				}
				return true;
			}
			
			if (ext=="jpg" || ext=="png") {				
				var width = 700;
				var height = 600;

				if (fEdit) {
					width = 1024;
					height = 600;
					WUI.openPopup ('popup_mediaplayer', { is_no_close: 0, is_no_resizeable : 0, is_no_modal: 0, width : width+100,  height : height+120,  topic : 'Bild bearbeiten ...', html : '<p style="position:absolute;top:40px;left:20px;" id="img_editor_loader"><img src="images/progress.gif" width="128" height="15" alt="" /></p><div style="text-align:center;"><div id="'+id+'"  style="margin-bottom:10px;"></div>', align : 'center', is_moveable : 1 } );
				}
				else {
					WUI.openPopup ('popup_mediaplayer', { is_no_close: 1, is_no_resizeable : 0, is_no_modal: 0, width : width+100,  height : height+120,  topic : basename, html : '<div style="text-align:center;"><div id="'+id+'"  style="margin-bottom:10px;"></div><div><a href="'+filename2+'" target="_blank">'+basename+'</a><br /><input onclick="WUI.closeMediaPlayer ();" id="upload_cancel_button" value="'+WLanguage.close+'" class="button delete_button" type="button"  /></div></div>', align : 'center', is_moveable : 1 } );
				}
				var htmlImg = '<div style="margin-left:auto;margin-right:auto;width:'+width+'px;height:'+height+'px;overflow:auto;"><img src="'+url+'" />';
				if (fEdit) {

					var htmlImg = '<iframe id="popup_mediaplayer_content_iframe" style="margin-left:auto;margin-right:auto;width:99.5%;height:'+(height+62)+'px;overflow:auto;border:0;" frameborder="0" src="../wlib/php/utils/imageeditor/index.php?imagesrc='+encodeURIComponent(filename)+'&editfield='+fEdit+'" />';
				}
				$('#'+id).html (htmlImg);

				
				return true;			
			}
			
		}
		return false;
	},
	
	
	showPopupFilter : function (color, opacity, fadeFunc) {	
		var extra = '';
		if (color)
			extra+='background-color:'+color+';';
		if (opacity)
			extra+='opacity:'+opacity+';filter:alpha(opacity='+(opacity*100)+');';
			
		$('#popup_filter').hide();	
		if (WSystem.ieVersion<7) {
			var filterHeight  = $(document).height()-4;
			if (filterHeight<$(window).height())
				filterHeight = $(window).height();
			$('#popup_filter').attr('style', extra+'position:absolute;left:0;top:0;display:block;width:100%;height:'+filterHeight+'px;');	
		}
		else
			$('#popup_filter').attr('style', extra+'position:fixed;left:0;top:0;display:block;width:100%;height:100%;');	


		$('#popup_filter').show();	

	},

	hidePopupFilter : function () {

		$('#popup_filter').hide();	
	},
	
	
	showDropDown : function (obj, name) {
		var box = '#'+name+'_box';
		var label = '#'+name+'_label';
		if (!document.getElementById (name+'_frame')) {			
			var div = document.createElement ('div');			
			var coords = WSystem.getAbsoluteCoords (obj);
			div.className = 'dropdown_box';
			div.style.left = coords.x+1+'px';
			div.style.top = coords.y+obj.offsetHeight+2+'px';
			$(div).width ($(box).width ());
			$(div).height ($(box).height ());
			div.id=name+'_frame';
			div.innerHTML = $(box).html ();
			$(div).css ('z-index', 90000);
			document.body.appendChild(div);			
			$(div).css ('min-width', ($(obj)[0].offsetWidth-2)+'px').show ();	
			WUI.currentDropDownBox='#'+div.id;
		}
	},

	selectDropDown : function (obj, name) {

		WUI.dropDownBoxVal = $(obj).attr('name');
		var text = $(obj).html ();		
		var box = '#'+name+'_box';
		var label = '#'+name+'_label';
		var value = '#'+name+'_ctrl';
		
		$(label).html (text).removeClass ('error');
		$(value).val (WUI.dropDownBoxVal);
		$(WUI.currentDropDownBox+' a').removeClass ('marked');	
		$(obj).addClass ('marked');
		
		var onchange = $(label).attr ('onchange');

		if (onchange) {
			WSystem.evalScript ('<script type="text/javascript">'+onchange+'</script>');
		}
		else	
			WSystem.fModified=true;		
		$(box).html ($(WUI.currentDropDownBox).html ());
		$(WUI.currentDropDownBox).remove ();
		WUI.currentDropDownBox = '';
	
	},
		
	openCalendarPopup : function (field, lang, time, session) {	
		WUI.currentCalendarField = field;
  	var url = WUI.calendarScript;
		WUI.closePopup ('popup_calendar');
		jQuery.ajax({ url: url+'?s='+(!session ? '' : session)+'&lang='+(!lang ? 'DE' : lang)+(!time ? '' : ('&time='+time)), success: function(data) {
			WUI.openPopup ('popup_calendar', { is_no_modal: 1, width : 210,  height : 280,  topic : WLanguage.calendar, html : '<div id="calendar">'+data+'</div>', is_no_resizeable : 1, is_moveable : 1 } );
		}});
	},
	
  calendarNav : function (year_month, lang, fProgess, year, month, time, session) {	
  	var url = WUI.calendarScript;
		if (fProgess)
			$('#calendar_header').html ('<div style="text-align:center;">'+WLanguage.loadCalendar+' ...</div>');
			
		$.ajax({ url: url+'?s='+(!session ? '' : session)+'&year_month='+year_month+'&lang='+(!lang ? 'DE' : lang)+'&year='+year+'&month='+month+'&time='+time, success: function(data) {
				$('#calendar').html (data);
		}});
	},
	
	calendarSelectDate : function (date) {		
		$('#'+WUI.currentCalendarField).trigger("change");
		$('#'+WUI.currentCalendarField).val (date);
		WUI.closePopup ('popup_calendar');
	}	
	
};

// Global init function
$(document).ready(function() {
	WSystem.addEvent (document, "contextmenu", function (evt) {
		if (!WUI.fSystemContextMenu) {
			if (window.event) {
				window.event.returnValue = false;
		   	window.event.cancelBubble = true;
			}
			else {
				evt.stopPropagation();
			}
		}
		else {
			if (window.event) {
				window.event.returnValue = true; 
		   	window.event.cancelBubble = false; 
			}
		}
		return false;
	});
	WSystem.addEvent (document, "mousedown", WUI.onDocumentMouseDown);
	WSystem.addEvent (document, "mousemove", WUI.onDocumentMouseMove);
	WSystem.addEvent (document, "mouseup", WUI.onDocumentMouseUp);
	WSystem.addEvent (window, "resize", function () { WUI.onWindowResize (''); window.setTimeout("WUI.onWindowResize ('ckeditor')", 100);} );
	WSystem.addEvent (window,  "beforeunload", WUI.windowBeforeUnload);
	
	WUI.onWindowResize ();
});

