<?php

/**

 WLayout

**/


class WLayout {

	private $props = array ();
	private $profile_id = 0;
	private $layoutList = array ();
	private $styleList = array ();
	private $page_layout_id = 0;
	private $basic_layout_id = 0;
	private $fSaveHTML = true;
	private $htmlList = array ();


	private function formatCSS ($css) {
		return str_replace (array ("\r\n"), array (""), $css);
	}

	public function __construct ($profile_id=0, $props=array()) {
		global $wdb;
		$this->profile_id = $profile_id;
		$this->props = $props;
		$this->layoutList = $wdb->queryTable (DB_TABLE_PREFIX."layout", "layout_id", "where is_deleted=0 and profile_id=".$profile_id." order by parent_layout_id, sort_pos"); 
		$this->styleList = $wdb->queryTable (DB_TABLE_PREFIX."layout", "layout_id", "where is_deleted=0 and profile_id=".$profile_id." and parent_layout_id=0 order by sort_pos", "name"); 
		
		foreach ($this->styleList as $basic_layout_id=>$name) {

			if ($name=="page")
				$this->page_layout_id = $basic_layout_id;
			
			if ($name=="basic")
				$this->basic_layout_id = $basic_layout_id;		
		}

	}
	
	public function getPageLayoutId () {
		return $this->page_layout_id;
	}
	public function getBasicLayoutId () {
		return $this->basic_layout_id;
	}
	public function getStyleList () {
		return $this->styleList;
	}
	public function getLayoutList () {
		return $this->layoutList;
	}

	public function createCss ($parent_layout_id=0, $prefix="", $parentPrefix="", $fParentOwnClass=false) {
		$css= "";
		
		if (!$fParentOwnClass)
			$prefix = $parentPrefix." ".$prefix;
		
		foreach ($this->layoutList as $layout_id => $data) {
			if ($data["parent_layout_id"]!=$parent_layout_id)
				continue;
				
			$fOwnClass = (substr (($data["name"]),0,1)==".");
			$fPseudoClass = (substr (($data["name"]),0,1)==":") || (substr (($data["name"]),0,1)=="[");
			
			$cssExtra = "";
			if (!empty ($data["file"])) {
				
				
				if ($data["file_is_bkg"])		
					if (empty ($data["file_style"]))
						$cssExtra.='background-image:url(/layout/'.$data["file"].');';				
					else		
						$cssExtra.='background:url(/layout/'.$data["file"].')'.(!empty ($data["file_style"]) ? ' '.$data["file_style"] : ';');
			}
				
			if ($data["has_children"]) 
			{
				if ($data["is_visible"]) 
				{
					$tokens = explode (",", $data["name"]);
					$cssTmp = "";
					foreach ($tokens as $name) {
						$name=trim ($name);
						if (!empty ($cssTmp))
							$cssTmp.=",";
						$fOwnClass2 = (substr ($name,0,1)==".");
						$fOwnClass3 = (substr ($name,0,1)=="~");
						if (!empty ($prefix) && (!$fOwnClass2 || $fOwnClass3)) {
							$cssTmp.=($prefix.($fPseudoClass||$fOwnClass3 ? "" : " "));
						}
						$cssTmp.=str_replace (array ("~"), array ("."), $name);

					}
					
					$css.=$cssTmp;
					$css.=' {'.$this->formatCSS($data["css"].$cssExtra).'}';
					
					$css.=$this->formatCSS($this->createCss ($layout_id, $data["name"], $prefix, $fOwnClass));
				}
				else	
				{	
					$css.=$this->formatCSS($data["css"].$cssExtra);
					$css.=$this->formatCSS($this->createCss ($layout_id));
				}
				
			}
			else 
			if ($data["is_visible"]) 
			{
				$tokens = explode (",", $data["name"]);
				$cssTmp = "";
				foreach ($tokens as $name) {
					$name=trim ($name);
					if (!empty ($cssTmp))
						$cssTmp.=",";
					$fOwnClass2 = (substr ($name,0,1)==".");
					$fOwnClass3 = (substr ($name,0,1)=="~");
					if (!empty ($prefix) && (!$fOwnClass2 || $fOwnClass3)) {
						$cssTmp.=($prefix.($fPseudoClass||$fOwnClass3 ? "" : " "));
					}
					$cssTmp.=str_replace (array ("~"), array ("."), $name);
				}
				
				$css.=$cssTmp;
			
				$css.=' {'.$this->formatCSS($data["css"].$cssExtra).'}';
			} 
			else 
			{
				$css.=$this->formatCSS($data["css"].$cssExtra);
			}
		
		}
		return $css."\n";
	}

	function createHTML ($layout_id, $fLive=false) {
		$this->fSaveHTML = true;
		$htmlFirst = $html = $this->createHTML2 ($this->page_layout_id, $fLive);
		if ($layout_id!=$this->page_layout_id) {
			$this->fSaveHTML = false;
			$html =  $this->createHTML2 ($layout_id, $fLive);
		}
		return $html;	
	}

	private function createHTML2 ($parent_layout_id=0, $fLive=false) {
		$html= "";
		foreach ($this->layoutList as $layout_id => $data) {
			if ($data["parent_layout_id"]!=$parent_layout_id)
				continue;
			
			if (!$data["is_gen_content"] && $fLive)
				continue;
			
			$class = $mainClass = "";
			if (substr ($data["name"],0,1)==".")
				$class = $mainClass = ltrim ($data["name"], ".");
			
			if (!empty ($data["layout_extra_class"])) {
				if (!empty ($class))
					$class.=" ";
				$class.=$data["layout_extra_class"];
			}
			if (!empty ($class))
				$class=' class="'.$class.'"';
				
			$attr = "";			
			if (!empty ($data["layout_attr"]))
				$attr=" ".$data["layout_attr"]." ";
				
			$content = $data["layout_content"];
			if ($fLive) {				
				if (!empty ($data["live_content"]))
					$content = $data["live_content"];
			}
				
	
			if (!$this->fSaveHTML && !empty ($mainClass) && isset ($this->htmlList[$mainClass])) {
				if (empty ($data["layout_content"]))
					$content=$this->htmlList[$mainClass];
			}
	
			if (!empty ($data["file"])) {
				
				
				if (!$data["file_is_bkg"])		
					$content.='<img src="layout/'.$data["file"].'"'.($data["file_alt_text"]!="" ? ' alt="'.$data["file_alt_text"].'"' : '').($data["file_style"]!="" ? ' style="'.$data["file_style"].'"' : '').' />';
			}
		/*
			if (!empty ($data["layout_in_class"]))
				$content = '<div class="'.$data["layout_in_class"].'">'.$content.'</div>';
		*/				
			if ($data["has_children"]) {
	
				for ($cnt =0;$cnt<$data["layout_replicate"];$cnt++) {
	
					if ($data["layout_element"]=="input")
					{
						$html.="<".$data["layout_element"].$attr.$class." />";				
					}
					else {
				
						if (!empty ($data["layout_element"]))
							$html.="<".$data["layout_element"].$attr.$class.">";
							
						if (!empty ($data["layout_in_class"]))
							$html.= '<div class="'.$data["layout_in_class"].'">';
							
						
						$htmlIn= $this->createHTML2 ($layout_id, $fLive);		
						if ($fSaveHTML) {
							$htmlIn=$content.$htmlIn;
							if (!empty ($mainClass) && !isset ($this->htmlList[$mainClass]))
								$this->htmlList[$mainClass]=$htmlIn;
						}
						else {
							if (empty ($htmlIn)) {
								$htmlIn=$content;
							}
						}
		
						$html.=$htmlIn;
			
						if (!empty ($data["layout_in_class"]))
							$html.= '</div>';
			
			
						if (!empty ($data["layout_element"]))			
							$html.="</".$data["layout_element"].">";	
					}
				}
			}
			else
			if (!empty ($data["layout_element"])) {
				
				$htmlIn = '';
				for ($cnt =0;$cnt<$data["layout_replicate"];$cnt++) {
					if ($data["layout_element"]=="input")
						$htmlIn.="<".$data["layout_element"].$attr.$class." />";	
					else
					{
						$htmlIn.="<".$data["layout_element"].$attr.$class.">";
					
						if (!empty ($data["layout_in_class"]))
							$htmlIn.= '<div class="'.$data["layout_in_class"].'">';
						$htmlIn.=$content;
						if (!empty ($data["layout_in_class"]))
							$htmlIn.= '</div>';
						
						$htmlIn.="</".$data["layout_element"].">";	
					}
				}
				
				if ($this->fSaveHTML) {
					if (!empty ($mainClass) && !isset ($this->htmlList[$mainClass]))
						$this->htmlList[$mainClass]=$htmlIn;
				}
				
	
				$html.=$htmlIn;
			}	
		}
		return $html;
	}
};

?>