<?php

/**

 WUI
 User interface, input fields ...

**/

class WUI
{
	const BUTTON_DEFAULT = "button";
	const BUTTON_SUBMIT = "submit";
	const INPUT_FRAME_ROWS = "input_frame_rows";
	const INPUT_FRAME_COLS = "input_frame_cols";

	private static $updateAreaList = array ();
	private static $message = array ("text"=>"", "type"=>"success");
	private static $question = array ("text" => "");
	private static $command = array ();
	private static $focusId = "";
	public  static $subPageId = "";
	public  static $ajaxMethod = "loadPage";
	
		
	private static function createAttributes ($props, $defaultClass="", $fOnlyStyle=false) {
		$attr = "";
		if ($props && is_array ($props)) {
			foreach ($props as $key => $value) {
				if ($key=="extra-class") {
					if (!empty ($defaultClass))
						$defaultClass.=" ";
					$defaultClass.=$value;
				}
				else
				if ($key=="class")
					$defaultClass.=$value;
				else
				if ($key=="style" && $fOnlyStyle)
					return $value;
				else
					$attr.= " ".$key."=\"".$value."\"";				
			}			
		}
		if (!empty ($defaultClass))
			$attr.=" class=\"".$defaultClass."\"";
		return $attr;
	}
	
	public static function createHiddenField ($name, $value, $fWrap=true) {
		$html="<input type=\"hidden\" id=\"".$name."_ctrl\" name=\"".$name."\" value=\"".htmlspecialchars ($value)."\" />";
		if ($fWrap)
			$html="<span id=\"".$name."\">".$html."</span>\n";
		return $html;
	}
	
	public static function createPreviewScript ($filename, $props=NULL) {	
		$version = "";
		if (isset ($props["version"])) {
			$version = $props["version"];
			unset ($props["version"]);
		}
		
		$script = '../wlib/php/utils/uploader'.$version.'/uploader.php';	
		if (isset($props["preview_script"]) && !empty ($props["preview_script"]))
			$script = $props["preview_script"];	
		$url = $script;	
		if (!empty ($filename))	{	
			$url.='?f='.$filename;
		}
		
		return WSystem::rebuildURI ($url, $props);		

	}

		
	// Old stuff
	public static function createUploadField ($description, $name, $filename, $path="", $props=NULL) {
		global $browser;
		if (!$props)
			$props=array();
		$version = "";
		if (isset ($props["version"])) {
			$version = $props["version"];			
		}
		if (defined ("NO_MODERN_UPLOADER")) {
			$props["version"]=$version="";
		}
		
	
		
		switch ($version) {
			case "2":
				// Ajax version
				$extra = "";
				if (empty ($filename))
					$extra = 'style="display:none;"';
				$extStr = "";
				if (isset ($props["files"])) {
					$list = explode (",", $props["files"]);
					foreach ($list as $ext) {
						if (!empty ($extStr)) {
							$extStr.=",";
						}
						$extStr.="'".$ext."'";
					}
				}
				$htmlInput =  
					'<div class="input_item">
						<div class="input_description">
							<span><!-->'.htmlspecialchars ($description).'<!--></span>
						</div>
						<div class="input_value">
							<div id="'.$name.'_upload_frame"></div>';
						$js='
				     <script type="text/javascript">        

		        	window.uploader_'.$name.' = new qq.FileUploader({
	              element: document.getElementById(\''.$name.'_upload_frame\'),
	              sizeLimit : '.WSystem::getConf ("max_upload_size").',
	              allowedExtensions: ['.$extStr.'],
	              action: \''.self::createPreviewScript ("",  array_merge ($props, array ("s"=>session_name(), "name"=>$name))).'\',
	              name : \''.$name.'\',
	              debug: false
		          });
				     </script>';
				     
				$editField = "'".$name."'";
				if (isset ($props["is_locked"]) && $props["is_locked"]) {
					$js = "";
					$editField = 'false';
				}
				$htmlInput.=
						 $js.'	    
						 <a '.$extra.' onclick="return !WUI.createMediaPlayer(this.href,false,'.$editField.');" class="upload_preview" id="'.$name.'_fullview_link" href="'.self::createPreviewScript ($path."/".$filename, array ("s"=>session_name(), "v"=>"fullview")).'" target="_blank">
								<img id="'.$name.'_preview_img" src="'.self::createPreviewScript ($path."/".$filename, array_merge ($props, array ("s"=>session_name()))).'&t='.time().'" />
	 					 </a>
 							'.
							self::createHiddenField ($name, $filename).
							self::createHiddenField ($name."_path", $path).
							self::createHiddenField ($name."_tmp", "").
							self::createHiddenField ($name."_tmp_orig", "").'
					   </div>
					 </div>';
				return $htmlInput;
				break;
				
			default:
				// iframe version
				$extra = "";
				if (empty ($filename))
					$extra = 'style="display:none;"';
				$htmlInput =  
					"<div class=\"input_item\">".
						"<div class=\"input_description\"><span><!-->".htmlspecialchars ($description)."<!--></span></div>".
						"<div class=\"input_value\"><iframe frameborder=\"0\" scrolling=\"no\" class=\"upload_frame\" name=\"".$name."_upload_frame\" src=\"".self::createPreviewScript ("",  array_merge ($props, array ("s"=>session_name(), "name"=>$name)))."\"></iframe>".
						"<div class=\"input_wrap_locked\" id=\"".$name."\">".self::createHiddenField ($name, $filename).self::createHiddenField ($name."_tmp", "").self::createHiddenField ($name."_tmp_orig", "")."</div></div>".
					"</div>";
				if (isset ($props["is_locked"]) && $props["is_locked"]) {
					$htmlInput = "";
				}
				$htmlInput.=
					"<a ".$extra." class=\"upload_preview\" id=\"".$name."_fullview_link\" href=\"".self::createPreviewScript ($path."/".$filename, array ("s"=>session_name(), "v"=>"fullview"))."\" target=\"_blank\"><img id=\"".$name."_preview_img\" src=\"".self::createPreviewScript ($path."/".$filename, array ("s"=>session_name()))."&t=".time()."\" /></a>\n";
				return $htmlInput;
				break;					
		}
	}

	
	public static function createInputField ($description, $name, $value, $props=NULL, $fRaw=false, $htmlAppend="") {
		$attr = self::createAttributes ($props, "inputfield");
		
		if (!isset ($props["type"]))
			$type = "text";
		else {
			$type = $props["type"];
			if ($type=="password")
				$attr.=' autocomplete="new-password" ';		
		}
						
		$htmlInput = "<div class=\"input_wrap".($type=="hidden" ? "_locked" : "")."\" id=\"".$name."\"><input".$attr." id=\"".$name."_ctrl\" name=\"".$name."\" type=\"".$type."\" value=\"".htmlspecialchars ($value)."\" /></div>".$htmlAppend;
		if (isset ($props["is_locked"]) && $props["is_locked"]) {
			
			if (filter_var($value, FILTER_VALIDATE_URL))
			{
				$value = '<a target="_blank" href="'.$value.'">'.htmlspecialchars ($value).'</a>';
			}
			else {
				$value = htmlspecialchars ($value);
			}
		
			$htmlInput = "<div class=\"input_wrap_locked\" style=\"".$props["style"].";overflow-wrap: break-word;\">".$value."</div>".$htmlAppend.self::createHiddenField ($name, $value, false);
		}

		if ($fRaw) {
			$html = "";
			if (!empty ($description))
				$html = "<span><!-->".htmlspecialchars ($description)."<!--></span>";
			return $html."<span>".$htmlInput."</span>";
		}
		return 
			"<div class=\"input_item\">".
				"<div class=\"input_description\"><span><!-->".htmlspecialchars ($description)."<!--></span></div>".
				"<div class=\"input_value\">".$htmlInput."</div>".		
			"</div>\n";
	}
	
	public static function createCalendarField ($description, $name, $value, $props=NULL, $fRaw=false, $htmlAppend="") {
		$attr = self::createAttributes ($props, "inputfield");
		
		if (!isset ($props["type"]))
			$type = "text";
		else
			$type = $props["type"];
			
		$t = WFormat::date2TimeValue ($value);
		
		$formatedValue =  WFormat::format ($value, "d");
		if (isset ($props["time_format"]) && $props["time_format"]=="t2")
			$formatedValue =  WFormat::format ($value, "t", false, 1);			
		
		$htmlCalSel = '<a href="#" onclick="WUI.openCalendarPopup (\''.$name.'_ctrl\', \''.LANGUAGE_CODE.'\''.(($value!=WFormat::getEmptyValue ("d") && $value!=WFormat::getEmptyValue ("t") ) ? ','.WFormat::date2TimeValue ($value) : ',null').',\''.session_name().'\');return false;" title="Kalender"><img src="images/calendar.png" alt="" width="16" height="16" style="vertical-align:middle;" /></a>';
				
	
		$htmlInput = "<div class=\"input_wrap\" id=\"".$name."\"><input".$attr." id=\"".$name."_ctrl\" name=\"".$name."\" type=\"".$type."\" value=\"".htmlspecialchars ($formatedValue)."\"></div><span>".$htmlCalSel."</span>".$htmlAppend;
		if (isset ($props["is_locked"]) && $props["is_locked"]) {
			$htmlInput = "<div class=\"input_wrap_locked\">".htmlspecialchars ($formatedValue)."</div>".$htmlAppend.self::createHiddenField ($name, $formatedValue, false);
		}
		
		if ($fRaw) {
			$html = "";
			if (!empty ($description))
				$html = "<span><!-->".htmlspecialchars ($description)."<!--></span>";
			return $html."<span>".$htmlInput."</span>";
		}
		return 
			"<div class=\"input_item\">".
				"<div class=\"input_description\"><span><!-->".htmlspecialchars ($description)."<!--></span></div>".
				"<div class=\"input_value\">".$htmlInput."</div>".		
			"</div>\n";
	}
	

	public static function createTextArea ($description, $name, $value, $props=NULL, $fRaw=false, $htmlAppend="") {
		$attr = self::createAttributes ($props, "textarea");
		
				
		$htmlInput = "<div class=\"input_wrap\" id=\"".$name."\"><textarea".$attr." id=\"".$name."_ctrl\" name=\"".$name."\">".htmlspecialchars ($value)."</textarea></div>".$htmlAppend;
		if (isset ($props["is_locked"]) && $props["is_locked"]) {
			$htmlInput = "<div class=\"input_wrap_locked\" style=\"".str_replace (array ("height"), array ("xxx"), $props["style"])."\">".nl2br (htmlspecialchars ($value))."</div>".$htmlAppend.self::createHiddenField ($name, $value, false);
		}
		if ($fRaw) {
			$html = "";
			if (!empty ($description))
				$html = "<span><!-->".htmlspecialchars ($description)."<!--></span>";
			return $html."<span>".$htmlInput."</span>";
		}
		return 
			"<div class=\"input_item\">".
				"<div class=\"input_description\"><span><!-->".htmlspecialchars ($description)."<!--></span></div>".
				"<div class=\"input_value\">".$htmlInput."</div>".	
			"</div>\n";
	}
		
	public static function createEditorArea ($description, $name, $value, $props=NULL, $fRaw=false, $htmlAppend="") {
		$version = WSystem::getConf ("editor_version", "ckeditor");
		$id = $name.'_ctrl';
		$resizeAttr = "";
		if (isset ($props["resizeAttr"])) {
			$resizeAttr = $props["resizeAttr"];
			unset ($props["resizeAttr"]);
		}	
		$fBBCode = false;	
		if (isset ($props["is_bbcode"])) {
			$fBBCode = !empty ($props["is_bbcode"]);
			unset ($props["is_bbcode"]);
		}

		if (isset ($props["version"])) {
			$version = $props["version"];
			unset ($props["version"]);
		}		
		
		$toolbar = "'CMS'";
		if (isset ($props["toolbar"])) {
			$toolbar = $props["toolbar"];
			unset ($props["toolbar"]);
		}		

		
		$width =  WSystem::getConf ("ckeditor_width", 800);
		$height = WSystem::getConf ("ckeditor_height", 300);
		if (isset($props["width"]))
			$width = $props["width"];
		if (isset($props["height"])) {
			$height = $props["height"];		
		}
		
		if ($version=="tinymce")
			$height+=100;
		
		if (!isset ($props["style"])) {
			$props["style"]="width:".$width."px;height:".$height."px";
		}
		$attr = self::createAttributes ($props, "textarea2");
		
		$htmlInput = "<textarea".$attr." id=\"".$name."_ctrl\" name=\"".$name."\">".htmlspecialchars ($value)."</textarea>".$htmlAppend;
		
		if (isset ($props["is_locked"]) && $props["is_locked"]) {
			$htmlInput = "<div class=\"input_wrap_locked\">".$value."</div>".$htmlAppend.self::createHiddenField ($name, $value, false);
		}

				
		if ($fRaw) {
			$html = "";
			if (!empty ($description))
				$html = "<span><!-->".htmlspecialchars ($description)."<!--></span>";
			return $html.$htmlInput;
		}
		if (defined ("NO_CKEDITOR"))
			$version = "textarea";
		switch ($version)
		{				
			case "textarea":
				$js = '
				<script type="text/javascript">
					'.(!empty ($resizeAttr) ? 'WUI.setResize (\'textarea_'.$id.'\', '.$resizeAttr.', -9, -7);' : '').'
					WUI.onWindowResize ();		
				</script>';
				
				break;
		
			case "tinymce":				
				$js = '
				<script type="text/javascript">
					if (!tinyMCE) {
						'.(!empty ($resizeAttr) ? 'WUI.setResize (\'textarea_'.$id.'\', '.$resizeAttr.', -9, -30);' : '').'
						$(\'<p class="error">TinyMCE editor is not supported. Please change WYSISWYG editor.</p>\').insertBefore (\'#'.$id.'\');
					}
					else
					{
						'.(!empty ($resizeAttr) ? 'WUI.setResize (\'tinymce_'.$id.'\', '.$resizeAttr.');' : '').'		
						
						jQuery (\'#'.$id.'\').parent().hide ();
						tinyMCE.execCommand(\'mceAddControl\', false, \''.$id.'\');
					}					
				</script>
				
				';
				break;

			default:
				$s = session_name ();
				$js = 
				'<script type="text/javascript">	
					if(!window.CKEDITOR) {
						$(\'<p class="error">CKEditor is not supported. Please change WYSISWYG editor.</p>\').insertBefore (\'#'.$id.'\');
					}
					else {
						var fNewInstance = true;


						if (fNewInstance) {
			
							if (!CKEDITOR.stylesSet.get (\'cms_styles\')) {
								
								CKEDITOR.stylesSet.add ( \'cms_styles\',
								[
									'.WSystem::getConf ("ckeditor_combo_styles", "").'
								]);
							}			
							jQuery (\'#'.$id.'\').parent().hide ();

							var fBBCode = '.($fBBCode ? '1' : '0').';
							
							var attr = { 								

								
							};
							
							function merge_options(obj1,obj2){
							    var obj3 = {};
							    for (var attrname in obj1) { obj3[attrname] = obj1[attrname]; }
							    for (var attrname in obj2) { obj3[attrname] = obj2[attrname]; }
							    return obj3;
							};
							
							if (fBBCode) {
								attr = {									
									extraPlugins: \'bbcode\',
									// Remove unused plugins.
									removePlugins: \'bidi,dialogadvtab,div,flash,format,forms,horizontalrule,iframe,justify,liststyle,pagebreak,showborders,stylescombo,table,tabletools,templates\',
									// Width and height are not supported in the BBCode format, so object resizing is disabled.
									disableObjectResizing: true,
									// Define font sizes in percent values.
									fontSize_sizes: "1/100%;2/120%;3/150%;4/200%;5/300%",
									toolbar: [
										[ \'Source\', \'-\', \'Save\', \'NewPage\', \'-\', \'Undo\', \'Redo\' ],
										[ \'Find\', \'Replace\', \'-\', \'SelectAll\', \'RemoveFormat\' ],
										[ \'Link\', \'Unlink\', \'Image\', \'Smiley\', \'SpecialChar\' ],
										\'/\',
										[ \'Bold\', \'Italic\', \'Underline\' ],
										[ \'FontSize\' ],
										[ \'TextColor\' ],
										[ \'NumberedList\', \'BulletedList\', \'-\', \'Blockquote\' ],
										[ \'Maximize\' ]
									],
									// Strip CKEditor smileys to those commonly used in BBCode.
									smiley_images: [
										\'regular_smile.gif\', \'sad_smile.gif\', \'wink_smile.gif\', \'teeth_smile.gif\', \'tounge_smile.gif\',
										\'embarrassed_smile.gif\', \'omg_smile.gif\', \'whatchutalkingabout_smile.gif\', \'angel_smile.gif\', \'shades_smile.gif\',
										\'cry_smile.gif\', \'kiss.gif\'
									],
									smiley_descriptions: [
										\'smiley\', \'sad\', \'wink\', \'laugh\', \'cheeky\', \'blush\', \'surprise\',
										\'indecision\', \'angel\', \'cool\', \'crying\', \'kiss\'
									]};
							}

							var c = CKEDITOR.replace( \''.$id.'\',  	merge_options (attr, {			
							 		allowedContent : true,
									contentsCss:\'css/ckeditor.css\',
									height: \''.$height.'\',
									width: \''.$width.'\',
									toolbar: '.$toolbar.',
									resize_enabled :'.(!empty ($resizeAttr) ? 'false' : 'true').',								
									on: 
					        {
					        	instanceReady : function( ev ) {
					        		
				        		var i = ev.editor.name;
			        			var html = \'\';
										try {
											html = ev.editor.dataProcessor.toHtml( ev.editor.getData ());
										}
										catch (e) {													
										}	
										WUI.ckEditorCheckList[i] = new CKEditorCheck (i, html);
				        		var id =$(\'#\'+i).closest(\'form\').parent ().parent ().attr (\'id\');
				        		if (id) {
											$(\'input.button:submit\').not(\'#\'+id+\' input.button:submit\').bind (\'click\', function (evt) {
											
												if (WUI.ckEditorCheckList[i] && WUI.ckEditorCheckList[i].checkModification ()) {
													if (!$(evt.target).attr("disabled")) {
														alert (WLanguage.saveSubFormular);
														$(evt.target).attr("disabled", true);
													}
													return false;
												}
												
											});										
										}
																				
										jQuery (\'#\'+i).parent().show ();
										'.(!empty ($resizeAttr) ? 'WUI.resize (\'ckeditor_'.$id.'\', '.$resizeAttr.');' : '').'
					
										}
					        }
								
								
							}));
							'.(!empty ($resizeAttr) ? 'WUI.setResize (\'ckeditor_'.$id.'\', '.$resizeAttr.');' : '').'			
						}
					}
					</script>';
				
				break;
		}
		
		if (isset ($props["is_locked"]) && $props["is_locked"]) {
			$js = "";
		}
		
		return 
			"<div class=\"input_item\">".
				"<p><!-->".htmlspecialchars ($description)."<!--></p>".
				"<div>".$htmlInput."</div>".
			"</div>\n".$js;
		return $html;
	}

	public static function createCheckBox ($description, $name, $value, $props=NULL, $fRaw=false, $htmlAppend="") {

		$type = "checkbox";
		$align = "right";
		if (isset($props["align"])) {
			$align = $props["align"];
			unset ($props["align"]);
		}
		if (!empty ($value))
			$value=1;
		else
			$value=0;

		$attr = self::createAttributes ($props, "checkbox");

		if ($value==1)
			$attr.=" checked";
			
		$yesNos = WLanguage::getYesNos ();

		$htmlInput = "<div class=\"input_wrap_checkbox\" id=\"".$name."\"><input".$attr." id=\"".$name."_ctrl\" name=\"".$name."\" type=\"".$type."\"></div>".$htmlAppend;
		if (isset ($props["is_locked"]) && $props["is_locked"]) {
			$htmlInput = "<div class=\"input_wrap_locked\">".$yesNos[$value]."</div>".$htmlAppend.self::createHiddenField ($name, $value, false);
		}
		if ($fRaw) {
			$html = "";
			if (!empty ($description))
				$html = "<span><!-->".htmlspecialchars ($description)."<!--></span>";
			return $html."<span>".$htmlInput."</span>";
		}
		if ($align=="right") {

			return 
				"<div class=\"input_item\">".
					"<div class=\"input_description\"><span><label for=\"".$name."_ctrl\"><!-->".htmlspecialchars ($description)."<!--></label></span></div>".
					"<div class=\"input_value\">".$htmlInput."</div>".		
				"</div>\n";
		}

		return 
			"<div class=\"input_item\">".
				"<div class=\"input_value\">".$htmlInput."<label for=\"".$name."_ctrl\"> <span><!-->".htmlspecialchars ($description)."<!--></span></label></div>".		
			"</div>\n";
			
	}

	public static function createDropDown2 ($description, $name, $value, $list, $props=NULL, $fRaw=false, $htmlAppend="") {
		$attr = self::createAttributes ($props, "dropdown");
		
		$extra = "";
		if (isset ($props["style"]))
			$extra.=' style="'.$props["style"].'" ';
		$fLocked = isset ($props["is_locked"]) && $props["is_locked"];	

		$htmlBox = "";

		$fHTMLChars = false;
		if (!isset ($props["no_html_chars"]) || $props["no_html_chars"]==0)
			$fHTMLChars = true;


		if (isset ($props["empty_option"])) {
			if ($props["empty_option"]==1)
				$emptyText = "---";
			else
				$emptyText = $props["empty_option"];		
			$htmlBox.='<a '.$extra2.' name="" href="#" onclick="WUI.selectDropDown(this,\''.$name.'\');return false;">'.htmlspecialchars ($emptyText).'</a>';
		}
		$label = $emptyText;		

		if (!isset ($props["no_html_chars"]) || $props["no_html_chars"]==0)
				$text = htmlspecialchars ($text);
		
		$fWasSelected = empty ($value);
		foreach ($list as $key => $text) {
			if (isset ($props["show_column"])) {
				$text = $text[$props["show_column"]];
			}
			$extra2 = "";
			if ($key==$value)
					$extra2 = ' class="marked" ';

			if ($key==$value || !$fWasSelected) {
				$label = $text;				
				if ($fHTMLChars)
					$label = htmlspecialchars ($label);
				$fWasSelected=true;
				$selectedText = $text;
			}
			if ($fHTMLChars)
				$text = htmlspecialchars ($text);
			$htmlBox.='<a '.$extra2.' name="'.$key.'" href="#" onclick="WUI.selectDropDown(this,\''.$name.'\');return false;">'.$text.'</a>';
		}
		
		$htmlBox = '<div id="'.$name.'_box" class="dropdown_box">'.$htmlBox.'</div>';
	
		$html = '<div class="input_wrap_empty" id="'.$name.'"><div class="dropdown">'.$htmlBox.'<input type="hidden" id="'.$name.'_ctrl" name="'.$name.'" value="'.$value.'" /><a '.$attr.' id="'.$name.'_label" onclick="WUI.showDropDown(this,\''.$name.'\');return false;" '.$extra.' href="#">'.$label.'</a></div><script type="text/javascript">$(\'#'.$name.'_label\').css (\'min-width\', ($(\'#'.$name.'_box\').width ()-10)+\'px\');</script></div>'.$htmlAppend;
				
		if ($fLocked) {
			if (empty ($selectedText) && !empty ($value))
				$selectedText = $value;
			if ($fHTMLChars)
				$selectedText = htmlspecialchars ($selectedText);
			$html = "<div class=\"input_wrap_locked\">".$selectedText."</div>".$htmlAppend.self::createHiddenField ($name, $value, false);
		}
		
		
		if ($fRaw)
			return $html;
		return 
			"<div class=\"input_item\">".
				"<div class=\"input_description\"><span><!-->".htmlspecialchars ($description)."<!--></span></div>".
				"<div class=\"input_value\">".$html."</div>".		
			"</div>\n";
	}



	public static function createDropDown ($description, $name, $value, $list, $props=NULL, $fRaw=false, $htmlAppend="") {
		$attr = self::createAttributes ($props, "dropdown");

		$htmlInput.="";
		$htmlInput.= 
			"<div class=\"input_wrap\" id=\"".$name."\">".
				"<select".$attr." id=\"".$name."_ctrl\" name=\"".$name."\">";
		
		if (isset ($props["empty_option"])) {
			if ($props["empty_option"]==1)
				$emptyText = "---";
			else
				$emptyText = $props["empty_option"];
			$htmlInput.="<option value=\"\" selected>".htmlspecialchars ($emptyText)."</option>";
			unset ($props["empty_option"]);
		}
		$selectedText = "";
		$fLocked = isset ($props["is_locked"]) && $props["is_locked"];
		
		$fWasSelected = empty ($value) && isset ($props["empty_option"]);
		foreach ($list as $key => $text) {
			if (isset ($props["show_column"])) {
				$text = $text[$props["show_column"]];
			}
			$selected = "";

			if ($key==$value && !$fWasSelected) {
				$fWasSelected=true;
				$selected = " selected";
				$selectedText = $text;

			}
			if (!isset ($props["no_html_chars"]) || $props["no_html_chars"]==0)
				$text = htmlspecialchars ($text);
			$htmlInput.= "<option value=\"".$key."\"".$selected.">".$text."</option>";
		}
		
		$htmlInput.="</select>".
			"</div>";			
		$htmlInput.=$htmlAppend;	
			
			
		if ($fLocked) {
			if (empty ($selectedText) && !empty ($value))
				$selectedText = $value;
			if (!isset ($props["no_html_chars"]) || $props["no_html_chars"]==0)
				$selectedText = htmlspecialchars ($selectedText);
			$htmlInput = "<div class=\"input_wrap_locked\">".$selectedText."</div>".$htmlAppend.self::createHiddenField ($name, $value, false);
		}
		
		if ($fRaw) {
			$html = "";
			if (!empty ($description))
				$html = "<span><!-->".htmlspecialchars ($description)."<!--></span>";
			return $html."<span>".$htmlInput."</span>";
		}
		
		return 
			"<div class=\"input_item\">".
				"<div class=\"input_description\"><span><!-->".htmlspecialchars ($description)."<!--></span></div>".
				"<div class=\"input_value\">".$htmlInput."</div>".		
			"</div>\n";
	}
	
	
	public static function createButton ($description, $name, $type=self::BUTTON_DEFAULT, $props=NULL, $fRaw=false, $htmlAppend="") {	
		if (!isset($props["extra-class"]) || strpos ($props["extra-class"], "_button")===false) {
			if (!isset($props["extra-class"]))
				$props["extra-class"]="default_button";
			else
				$props["extra-class"].=" default_button";	
		}
		$attr = self::createAttributes ($props, "button");
		$htmlInput = "<input".$attr." id=\"".$name."_ctrl\" name=\"".$name."\" type=\"".$type."\" value=\"<!-->".$description."<!-->\" />".$htmlAppend;
		if ($fRaw) {
			return "<span>".$htmlInput."</span>";
		}
		return 
			"<div class=\"input_item\">".
				$htmlInput.		
			"</div>\n";
	}

	public static function createViewButton ($text, $view="new", $fSpan=false, $fNoFreeInstances=false) {
		$allowedClasses = array ("new_button", "edit_button", "search_button", "delete_button");
		$viewClass = $view."_button";
		if (!isset($allowedClasses[$viewClass]))
			$viewClass="new_button";

		$html = "<input type=\"button\" class=\"button ".$viewClass."\" onclick=\"WUI.".WUI::$ajaxMethod." ('".WSystem::getRequestURI (array ("view"=>$view, "view_prev" => (WSystem::getParam ("view")!="init") ? WSystem::getParam ("view") : "")+array ("page_is_ajax"=>1), true)."', '".WUI::$subPageId."', '', '', ".($fNoFreeInstances ? "true" : "false").");return false;\" value=\"<!-->".htmlspecialchars ($text)."<!-->\" />";
		if ($fSpan)
			return "<span>".$html."</span>";
		return "<p>".$html."</p>";

	}
		
	public static function createViewLink ($text, $view="", $fSpan=false) {
		$html = "<a href=\"\" onclick=\"WUI.".WUI::$ajaxMethod." ('".WSystem::getRequestURI (array ("view"=>$view)+array ("page_is_ajax"=>1))."','".WUI::$subPageId."');return false;\"><!-->".htmlspecialchars ((empty ($text) ? "Zurück" : $text))."<!--></a>";
		if ($fSpan)
			return "<span>".$html."</span>";
		return "<p>".$html."</p>";
	}
	
	public static function createHeader ($description, $props=NULL) {		
		$htmlRight="";
		if ($props) {
			
		}		
		$html="<div ".self::createAttributes ($props, "box_header").">".$htmlRight."<span><!-->".htmlspecialchars ($description)."<!--></span></div>";
		return $html;
	}
	
	public static function createBox ($props, $htmlContent) {	
		if ($props) {
			if (!isset ($props["style"]))
				$props["style"]="";
			if (isset ($props["float"])) {
				switch ($props["float"]) {
					case "right":
						$props["style"].="float:right;margin-left:15px;";						
						break;
				}
				unset ($props["float"]);
			}		
		}
		$html = "<div ".self::createAttributes ($props, "box").">".$htmlContent."</div>";
		return $html;
	}
	
	public static function create2Columns ($htmlCol1, $htmlCol2, $propsCol1=NULL, $propsCol2=NULL) {

		return '
			<table class="column_frame">
				<tr>
					<td class="col1x1" style="'.self::createAttributes ($propsCol1,"",true).'">'.$htmlCol1.'</td>
					<td class="col1x2" style="'.self::createAttributes ($propsCol2,"",true).'">'.$htmlCol2.'</td>
				</tr>
			</table>';
		
	}

	public static function create3Columns ($htmlCol1, $htmlCol2, $htmlCol3, $propsCol1=NULL, $propsCol2=NULL, $propsCol3=NULL) {

		return '
			<table class="column_frame">
				<tr>
					<td class="col1x1" style="'.self::createAttributes ($propsCol1,"",true).'">'.$htmlCol1.'</td>
					<td class="col1x2" style="'.self::createAttributes ($propsCol2,"",true).'">'.$htmlCol2.'</td>
					<td class="col1x3" style="'.self::createAttributes ($propsCol3,"",true).'">'.$htmlCol3.'</td>
				</tr>
			</table>';
		
	}
	

	public static function create1x2Columns ($htmlCol1, $htmlCol2, $htmlCol3, $propsCol1=NULL, $propsCol2=NULL, $propsCol3=NULL) {

		return '
			<table class="column_frame">
				<tr>
					<td class="col1x1" colspan="2" style="'.self::createAttributes ($propsCol1,"",true).'">'.$htmlCol1.'</td>
				</tr>
				<tr>					
					<td class="col2x1" style="'.self::createAttributes ($propsCol2,"",true).'">'.$htmlCol2.'</td>
					<td class="col2x2" style="'.self::createAttributes ($propsCol3,"",true).'">'.$htmlCol3.'</td>
				</tr>
			</table>';
		
	}
	
	public static function create2x1Columns ($htmlCol1, $htmlCol2, $htmlCol3, $propsCol1=NULL, $propsCol2=NULL, $propsCol3=NULL) {

		return '
			<table class="column_frame">
				<tr>					
					<td class="col2x1" style="'.self::createAttributes ($propsCol1,"",true).'">'.$htmlCol1.'</td>
					<td class="col2x2" style="'.self::createAttributes ($propsCol2,"",true).'">'.$htmlCol2.'</td>
				</tr>
			<table>
			<table class="column_frame">
				<tr>
					<td class="col1x1" colspan="2" style="'.self::createAttributes ($propsCol3,"",true).'">'.$htmlCol3.'</td>
				</tr>
				
			</table>';
		
	}
	
	public static function createInputFrame ($mode, $props, $htmlContent) {	
		$attr = self::createAttributes ($props, $mode);
		return "<div ".$attr.">\n".$htmlContent."</div>";
	}

	public static function createForm ($id, $htmlContent, $action="") {
		if (empty ($action))
			$action=$_SERVER["REQUEST_URI"];
		$html = 
		'<form onsubmit="WUI.submitForm (\''.$id.'\', \''.$action.'\');return false;" id="'.$id.'" method="post" action="'.$action.'" enctype="multipart/form-data">
			'.$htmlContent.'
		</form>';
		return $html;
	}	

	public static function command ($props) {
		global $session;
		header("Content-Type: text/plain");
		header("Connection: close");


		
		// Translate update areas
		foreach (self::$updateAreaList as $id => $html) {	
		
			self::$updateAreaList[$id] = $session->translate ($html);
		}

		// JSon complete request
		$json = array_merge (			
			array ("question" => self::$question), 
			array ("updateAreas" => self::$updateAreaList), 
			array ("message" => self::$message), 
			self::$command,
			$props);
			
		// Translate popups
		if (isset($json["popups"])) {
			foreach ($json["popups"] as $id => $props2) {	
				$props2["html"]  = $session->translate ($props2["html"]);
				$props2["topic"] = $session->translate ($props2["topic"]);
				$json["popups"][$id] = $props2;
			}
		}

		print (json_encode ($json));
		exit;
	}
		
	public static function commandAsync ($props) {
		self::$command = array_merge (self::$command, $props);
	}
	
	public static function redirect ($uri, $postParams=array()) {	
		$postData = "";
		foreach ($postParams as $key=>$value) {
			if (!empty ($postData))
				$postData.="&";
			$postData.=$key."=".urlencode ($value);
		}
		if (self::$ajaxMethod=="loadPage") {
			self::$command["freePageInstances"]=1;
		}
		self::command (array ("redirectURI" => $uri, "postData" => $postData));
	}
	
	public static function download ($uri) {	
		self::command (array ("downloadURI" => $uri));
	}
	
	public static function updateArea ($id, $html, $props=array ()) {	
		self::$updateAreaList[$id]=$html;
		self::command ($props);
	}
	
	public static function updateAreaAsync ($id, $html) {
		self::$updateAreaList[$id]=$html;
	}	

	public static function updateForm ($values, $hideId="") {	
		self::command (array (
				"fields" => $values, 
				"hideId" => $hideId,
			));
	}
	
	public static function openPopup ($id, $topic, $html, $props=array()) {	
		self::command (array ("popups" => array ($id => array_merge (array ("topic" => "<!-->".$topic."<!-->", "html" => $html), $props))));
	}
	
	public static function openPopupAsync ($id, $topic, $html, $props=array()) {	
		self::commandAsync (array ("popups" => array ($id => array_merge (array ("topic" => "<!-->".$topic."<!-->", "html" => $html), $props))));
	}
		
	public static function closePopup ($id) {
		self::command (array (
				"closePopupId" => $id
			));
	}	

	public static function removeDragableAsync ($id) {		
		self::$command["removeDragableId"]=$id;
	}

	public static function closePopupAsync ($id) {
		self::$command["closePopupId"]=$id;
	}
	
	public static function setMessage ($text, $type="success") {
		self::$message = array ("text"=>$text, "type" => $type);
	}
	
	public static function checkUnsavedModification ($on=true) {
	
		WUI::commandAsync (array ("checkUnsavedModification" => ($on ? 2 : 1)));

	}
	
	public static function setConfirm ($text) {
		self::$question= array ("text"=>$text);
	}
	
	public static function setRetry ($on) {
		self::$command["retry"] = $on;
	}
	
	public static function isConfirm () {
		return ((int) WSystem::getParam ("is_confirm")) == 1;
	}
	
	public static function setFocusId ($id) {
		self::$focusId = $id;
	}
	
	public static function getFocusId () {
		return self::$focusId;
	}
	
};

/**

 WUIElement
 Parent class for all complex UI elements

**/

abstract class WUIElement
{
	protected $id = "";
	protected $html = "";	
	private static $instanceCnt = 0;
	protected $fRenderOnlyContent = false;
	
	public function __construct ($id) {

		
		$this->id = $id;
		
		self::$instanceCnt++;
		if (self::$instanceCnt>1)
			$this->id.="_frame_".self::$instanceCnt;
	}

	public function getElementId () {
		return $this->id;
	}
	
	public function resetElement () {
		$this->html = "";
	}
	
	public abstract function renderElement ();

	public function __clone() {
		$this->html = "";
		
		$this->id = $this->getElementId (); //.rand ();
		self::$instanceCnt++;
		if (self::$instanceCnt>1)
			$this->id.="_frame_".self::$instanceCnt;

		$this->renderElement ();
	}
	
	public function setRenderOnlyContent ($on) {
		$this->fRenderOnlyContent = $on;
	}
	
	
	public function show ($fAsync=true) {
		$this->setRenderOnlyContent (true);
		$this->renderElement ();
		if ($fAsync)
			WUI::updateAreaAsync ("wrap_".$this->getElementId(), $this->html);
		else
			WUI::updateArea ("wrap_".$this->getElementId(), $this->html);
	}

	public function __toString () {
		if (empty ($this->html)) {
			try {
				$this->renderElement ();
			}
			catch (Exception $e) {
				WSystem::createHTMLException ($e);
			}
		}
		return $this->html;
	}	
};

?>