<?php

/**

 WVideoUtils

**/

abstract class WVideoUtils
{
	public static function ffprobe ($filename, $ffprobe_path="/usr/bin/ffprobe", &$errText=NULL) {
		$streamList = array ();
		ob_start ();	
		$ret = 0;
		system ($ffprobe_path." -show_streams  ".$filename, $ret);
		$str = ob_get_contents();
		ob_end_clean ();
		if ($ret) {
			if ($errText)
				$errText = $str;
		}
		else {
			$i=0;
	
			$tokens = explode ("\n", $str);
			foreach ($tokens as $token) {
				$token = trim ($token);
				if (empty ($token))
					continue;
					
				if ($token=="[/STREAM]")
					continue;
					
				if ($token=="[STREAM]") {
					$i++;
					continue;
				}
				list ($key, $value) = explode ("=", $token);
				$streamList[$i][$key]=$value;	
			}
		}
		
		return $streamList;
	}
	
	public static function getBasicVideoProps ($filename, $ffprobe_path="/usr/bin/ffprobe", &$errText=NULL) {
		$props = array (
			"video_codec" => "",
			"video_width" => 0,
			"video_height" => 0,
			"audio_codec" => ""
		);
		
		$streamList = self::ffprobe ($filename, $ffprobe_path, $errText);
		foreach ($streamList as $stream) {
			switch ($stream["codec_type"]) {
				case "video":				
					$props["video_codec"]=$stream["codec_name"];
					$props["video_width"]=$stream["width"];
					$props["video_height"]=$stream["height"];
					break;				
				case "audio":
					$props["audio_codec"]=$stream["codec_name"];
					break;
			}
		}
		return $props;
	}

	public static function ffconvert ($filename, $filename2, $videoCodec, $params="", $ffmpeg_path="/usr/bin/ffmpeg", &$errText=NULL) {
		$ret = 0;
		ob_start ();
		$cmdLine = 	$ffmpeg_path." -i  ".$filename." -vcodec ".$videoCodec." ".$params." ".$filename2;

		system ($cmdLine, $ret);	
		$str = ob_get_contents();
		ob_end_clean ();
		if (!$ret) {
			return true;
		}
		

		if ($errText)
			$errText = $str;
		return false;
	}	
	
	
	public static function qtFaststart ($filename, $filename2, $qtfaststart_path="/usr/bin/qt-faststart", &$errText=NULL) {
		$ret = 0;
		ob_start ();	
		system ($qtfaststart_path." \"".$filename."\" \"".$filename2."\"", $ret);
		$str = ob_get_contents();
		ob_end_clean ();
		
		if (strpos ($str, "last atom in file was not a moov atom")===false) {
			return true;
		}
		if ($errText)
			$errText = $str;
		
		return false;
	}	
	
	
}

?>