<?php


class UniversalForm extends WForm
{
	private $props = NULL;
	private $logic = NULL;
	protected $connector = NULL;
	protected $fNoDelete = false;
	protected $fNoSave = false;
	protected $fSimple = false;
	protected $fButtonsTop = false;
	protected $fAutoHeight = true;
	protected $fSaveTab = false;
	protected $fLockAll = false;
	protected $tabStyle = "width:100%;";
	protected $tabStyle2 = "";
	protected $createText = WLanguage::CREATE;
	protected $deleteText = WLanguage::DELETE;
	protected $saveText = WLanguage::SAVE;
	protected $extraBtFunc = NULL;

		
	public function __construct (&$props, &$logic, &$connector=NULL, $actionURI="", $successURI="") {

		
		$this->logic = &$logic;
		$this->props = &$props;
		$this->connector = &$connector;
		if (empty ($successURI))
			$successURI = WSystem::getRequestURI(array ("view"=>WSystem::getParam ("view_prev")));

		$mode = WSystem::getArrayValue ($this->props, "input_mode");
		$list = explode ("|", $mode);
		foreach ($list as $mode) {
		
			if (strpos ($mode, "=")!==false) {
				list ($mode, $value) = explode ("=", $mode);
			}
			
			switch ($mode) {
				case "no_delete":
					$this->fNoDelete=true;
					break;
				case "no_save":
					$this->fNoSave=true;
					break;
				case "simple":
					$this->fSimple=true;
					$successURI="";
					break;
				case "buttons_top":
					$this->fButtonsTop=true;
					break;
				case "tab_width":
					$this->tabStyle.="width:".$value;
					break;
				case "tab_height":
					$this->tabStyle2.="min-height:".$value;
					break;
				case "save_text":
					$this->saveText=$value;
					break;					
				case "create_text":
					$this->createText=$value;
					break;														
				case "delete_text":
					$this->deleteText=$value;
					break;										
				case "no_auto_height":
					$this->fAutoHeight=false;
					break;
				case "save_tab":
					$this->fSaveTab=true;
					break;
				case "lock_all":
					$this->fLockAll=true;
					break;
			}
		}
		
		$cmd = WSystem::getParam ("view");
		$list= explode ("_", $cmd);
		$i = count ($list);
		if ($i>0) {
			$cmd = $list[$i-1];
		}


		if ($cmd!="new" || empty ($cmd)) {
			$cmd="edit";
		}

		if ($cmd=="edit" && $this->logic->fTreeView)
			$successURI = "";
			
		if (isset ($props["extra_button_func"]))
			$this->extraBtFunc = $props["extra_button_func"];

		parent::__construct ($this->props["name"]."_form", $cmd, $actionURI, $successURI);
	}
	
	public function __destruct () {
	
	}
	
	public function getDefinition () {
		return $this->logic->inputDef;
	}
	

	private static function mergeAllowedProps (&$props, &$props2, $allowedProps) {
		foreach ($allowedProps as $key => $value) {
			if (!isset ($props[$key])) {
				
				if (isset ($props2[$key])) {
					$props[$key]=$props2[$key];
				}
				else 
				if ($value!=NULL)
				{
					$props[$key]=$value;
				}
			}
		}
		return $props;
	}


	public static function createInputField ($field, &$fieldProps, $value, $fLocked=false, $fRaw=false, $htmlAppend="") {
	
		$attrList = explode (";", $fieldProps["input"]);
		$f = $attrList[0];
		$mode = $attrList[1];
		if (isset ($fieldProps["is_locked"]) && $fieldProps["is_locked"] && 
				isset ($fieldProps["not_empty"]) && $fieldProps["not_empty"]) {
			
			if ($value==WFormat::getEmptyValue ($f))
				return "";
		}
		
		$field2 = trim ($field, '~');
		if ($field2!=$field) {
			// Only for showing
			$field=$field2;
		}
		$props = array ();
			
		$props = self::mergeAllowedProps ($props, $fieldProps, array ("style" => NULL, "is_locked" => $fLocked));
		

		list ($type, $format) = explode (":", $fieldProps["type"]);
		
	
		
		if 	(!empty ($format)) {
			switch ($format) {
				case "kb":
					$value = WFormat::formatKBText ($value); 

				case "t2":
					$value = WFormat::format ($value, "t", $fLocked, true); 
					break;

				default:
					$value = WFormat::format ($value, $format, $fLocked); 
					break;
			}
		}			


		switch ($type) {
			case "empty":
				break;
				
			case "hidden":
				$htmlField=WUI::createHiddenField ($field,  $value);
				break;
				
			case "textarea":
				$htmlField=WUI::createTextArea ($fieldProps["name"], $field,  $value, $props, $fRaw, $htmlAppend);
				break;

			case "html":
				$htmlField=WUI::createEditorArea ($fieldProps["name"], $field, $value, self::mergeAllowedProps ($props, $fieldProps, array ("is_bbcode" => 0, "version"=>WSystem::getConf ("editor_version", "ckeditor"), "width" => 800, "height"=>600, "toolbar"=>"", "resizeAttr" => "{ target : '.tabulator_content_frame_in', offsetY : -40 }")));
				break;
								
			case "calendar":
				$htmlField=WUI::createCalendarField ($fieldProps["name"], $field, $value, self::mergeAllowedProps ($props, $fieldProps, array ("time_format" => "")), $fRaw, $htmlAppend);
				break;


			case "upload":
				$uploadPath = ""; 
				if (isset ($fieldProps["upload_path"]))
					$uploadPath = $fieldProps["upload_path"]; 
				if (isset ($fieldProps["not_empty"]) && $fieldProps["not_empty"] && empty ($value))		
					$htmlField="";
				else
					$htmlField=WUI::createUploadField ($fieldProps["name"], $field, $value, $uploadPath, self::mergeAllowedProps ($props,  $fieldProps, array ("resize" => NULL, "preview_script"=>"", "version" => "", "files" => WSystem::getConf ("upload_files"))));
				break;

			case "checkbox":
				$htmlField = WUI::createCheckBox ($fieldProps["name"], $field, $value, $props, $fRaw, $htmlAppend);
				break;
				
			case "dropdown":
				if (isset ($fieldProps["not_empty"]) && $fieldProps["not_empty"] && !count ($fieldProps["choices"]))		
					$htmlField="";
				else
					$htmlField.=WUI::createDropDown ($fieldProps["name"], $field, $value, $fieldProps["choices"],  self::mergeAllowedProps ($props,  $fieldProps, array ("show_column" => NULL, "empty_option" => 0, "onchange"=>NULL)), $fRaw, $htmlAppend);
				break;
				
			case "text":
			default:
				$props["type"]=$type;
				if ($type=="password")
					$value = "";
				$htmlField = WUI::createInputField ($fieldProps["name"], $field, $value, $props, $fRaw, $htmlAppend);
				break;
		}	
		return $htmlField;
	}
	
	
	public function renderInputElement ($field, &$fieldProps, &$value, $fLocked, &$values) {

		return false;
	
	}
	

	public function createMask ($cmd, $values) 
	{
		global $wdb, $session;
		
		

		$itemData = $this->connector->select ();
		if (!$itemData && $cmd!="new") {
			
			WUI::commandAsync (array ("freePageInstances" => 1)); // for CKEditor

			return "";
			
		}

		$fLocked = !$session->isScriptEditable ();
		
		if ($this->fLockAll) {
			// $fLocked=true;
		}

		$tab = new WUITabulator ($this->props["name"]."form_tab", $this->tabStyle, false, false, $this->tabStyle2);
		$tab->setSaveTab (($this->fSaveTab || $this->logic->fTreeView) && $cmd!="new");
		$tab->setRightInfo (($cmd=="edit" ? "<p>".WLanguage::CREATED.": ".WFormat::formatDateTime ($values["created"], true).((!WDB::isDateEmpty ($values["changed"])) ? " - ".WLanguage::CHANGED.": ".WFormat::formatDateTime ($values["changed"], true) : "")."</p>" : ""));
		$tab->setAutoHeight ($this->fAutoHeight);
		
		$tabIdx=$fieldIdx=1;
		
		$ignoreFields = array ();
		foreach ($this->props["input_form"] as $tabProps) {
			if (isset ($tabProps["dynamic_content"])) {
					$if = 'if (!$(\'#'.$tabProps["dynamic_content"].'\').html ()) ';
					if (isset ($tabProps["dynamic_content_reload"]) && $tabProps["dynamic_content_reload"]) {
						$if = "";
					}
					
					$tab->addPage (
						$tabProps["name"], 
							WUI::createInputFrame (
								WUI::INPUT_FRAME_ROWS, 
								array ("id"=>$this->id."_input_frame".$tabIdx), 
								'<div id="'.$tabProps["dynamic_content"].'"></div><script type="text/javascript">function load'.$tabProps["dynamic_content"].' () { WUI.ajaxRequest (\''.WSystem::getRequestURI(array ("view"=>$tabProps["dynamic_content"])).'\', \''.$tabProps["dynamic_content"].'\', null, true, \'init=1\', false); };</script>'
								), $if.' load'.$tabProps["dynamic_content"].'();'
					);
					$tabIdx++;
					continue;
			}		
				
			$htmlTab = "";
			$htmlColumns = array (1 => "", 2 => "", 3 => "", "2x1" => "");

			foreach ($tabProps["input_fields"] as $field => $fieldProps) {

				if ($this->fLockAll) {
					$fieldProps["is_locked"]=1;
				}

				if (isset ($ignoreFields[$field])) {
					continue;
				}
				if ($fieldProps["type"]=="element") {
					$element = &$fieldProps["element"];
					$inputRet=$this->renderInputElement ($field, $fieldProps, $values[$field], $fLocked, $values);
					if ($inputRet===false) {
						$element->init ($field, $this->connector->getPrimaryId (), $this->props, $fieldProps);
						$htmlField =$element->__toString ();
					}
					else {
						$htmlField = $inputRet;
					}
				}
				else {
				

					$inputRet=$this->renderInputElement ($field, $fieldProps, $values[$field], $fLocked, $values);

					
					if ($inputRet===false) {
						

						
						// Append fields
						$htmlAppend = "";
						if (isset ($fieldProps["append_fields"])) {
							$list = explode (",", $fieldProps["append_fields"]);
							foreach ($list as $field2) {
								if (isset ($tabProps["input_fields"][$field2])) {

									if ($this->fLockAll) {
										$tabProps["input_fields"][$field2]["is_locked"]=1;
									}

									$htmlAppend.=self::createInputField ($field2, $tabProps["input_fields"][$field2], $values[$field2], $fLocked, true);
									$ignoreFields[$field2]=1;
								}
							}
						}

						

						// Optional fields
						
						if (isset ($fieldProps["optional_fields"])) {
							$list = explode (",", $fieldProps["optional_fields"]);
							$fPlus = false;
							foreach ($list as $field2) {
								if (isset ($tabProps["input_fields"][$field2])) {
									$display="";
									if (empty ($values[$field2])) {
										$display="display:none";
										$fPlus=true;
									}
									$htmlAppend.='<div id="optional_'.$field.'" style="margin-left:-5px;margin-top:4px;'.$display.'">'.self::createInputField ($field2, $tabProps["input_fields"][$field2], $values[$field2], $fLocked, true).'</div>';
									$ignoreFields[$field2]=1;
								}
							}	
							if ($fPlus)						
								$htmlAppend='<a title="Zusatzfeld" href="#" onclick="$(\'#optional_'.$field.'\').show ();$(this).hide();return false;"><img style="vertical-align:middle;" src="images/tree/nolines_plus.gif" alt="" /></a>'.$htmlAppend;
						}
						

						$htmlField = self::createInputField ($field, $fieldProps, $values[$field], $fLocked, false, $htmlAppend);
					
					}
					else
						$htmlField = $inputRet;
				}
				
				if (isset ($fieldProps["visible"]) && $cmd!=$fieldProps["visible"]) {
					
					$htmlField = WUI::createHiddenField ($field, $fieldProps["type"]!="password" ? $values[$field] : "");
				}
				
				$colIdx = isset ($fieldProps["column"]) ? $fieldProps["column"] : 1;

				
				if ($fieldIdx==1) {

					if ($cmd=="edit") {
						// Primary
						$htmlColumns[$colIdx].=WUI::createHiddenField ($this->props["primary_column"], $values[$this->props["primary_column"]]);
					}

					if ($this->logic->fTreeView) {
						// Parent
						$htmlColumns[$colIdx].=WUI::createHiddenField ("parent_".$this->props["primary_column"], $values["parent_".$this->props["primary_column"]]);
					}
				}

				$htmlColumns[$colIdx].=$htmlField;				
				$fieldIdx++;
			}
			$htmlContent = "";
	
			if (!empty ($htmlColumns["2x1"])) {
				$htmlContent = 	WUI::create2x1Columns (	$htmlColumns[1], $htmlColumns[2], $htmlColumns["2x1"], $tabProps["column1_props"], $tabProps["column2_props"], $tabProps["column3_props"]);
			}
			else
			if (!empty ($htmlColumns[3])) {
				$htmlContent = 	WUI::create3Columns (	$htmlColumns[1], $htmlColumns[2], $htmlColumns[3], $tabProps["column1_props"], $tabProps["column2_props"], $tabProps["column3_props"]);
			}
			else
			if (!empty ($htmlColumns[2])) {
				$htmlContent = 	WUI::create2Columns (	$htmlColumns[1], $htmlColumns[2], $tabProps["column1_props"], $tabProps["column2_props"]);
			}
			else
			if (!empty ($htmlColumns[1])) {
				$htmlContent = 	$htmlColumns[1];
			}
			$fVisible = true;
			if (isset ($tabProps["visible"]) && empty ($tabProps["visible"])) {
				$fVisible = false;
			}
			
			if ($fVisible) {
				$tab->addPage ($tabProps["name"], WUI::createInputFrame (WUI::INPUT_FRAME_ROWS, array ("id"=>$this->id."_input_frame".$tabIdx), $htmlContent));
			}
			$tabIdx++;
		}

		$deleteQuestion = WUtils::templateText (WSystem::getArrayValue ($this->props, "texts", WLanguage::DELETE_QUESTION, "delete_question"), $values);
		if ($this->logic->fTreeView) {
			
			$html  = "";
			$topic = "";
			if ($cmd=="new") {
				if ($itemData)
					$topic = WUtils::templateText ($session->getLangVar ("TREEVIEW_INSERT", "... unter '{name}' einfügen."), $itemData);
				else
					$topic = $session->getLangVar ("TREEVIEW_INSERT_FIRST", "... in der 1. Ebene einfügen.");
				$html.="<p><b>".htmlspecialchars ($topic)."</b></p>";
			}
		
			$btProps = array ("treeView" => $this->connector, "deleteQuestion" => $deleteQuestion);
			if (!empty ($this->extraBtFunc)) {
				$btProps["extra_button_func"]=$this->extraBtFunc;
			}
		
			
			$htmlButtons = $this->createCommandButtons ($cmd, $btProps);

			if ($cmd!="new") {
				$html.= '<div style="'.$this->tabStyle.'">'.$htmlButtons.'</div>';

				$htmlButtons = "";
			}			
			$html.= $this->createHideableFrame ($tab.$htmlButtons);
			return 
				$this->createHideableFrame (	$html ).
				($cmd=="new" ? WUI::createViewLink (WLanguage::BACK_TO_OVERVIEW, (WSystem::getParam ("view_prev")!="init" ?  WSystem::getParam ("view_prev") : "") ) : "");
		}		
		else {
		

		
			$btProps = array ("save_text"=>$this->saveText, "delete_text"=>$this->deleteText, "create_text"=>$this->createText, "no_save" => $this->fNoSave, "no_delete" => $this->fNoDelete, "deleteQuestion" => $deleteQuestion);
			if (!empty ($this->extraBtFunc)) {
				$btProps["extra_button_func"]=$this->extraBtFunc;
			}


			$htmlButtons = '<div style="'.$this->tabStyle.'">'.(!$fLocked ? $this->createCommandButtons ($cmd,  $btProps) : '').'</div>';
			return 
			 $this->createHideableFrame (
				 ($this->fButtonsTop ? $htmlButtons : '').$tab.(!$this->fButtonsTop ? $htmlButtons : '')
				 
			 ).
			 (!$this->fSimple ? WUI::createViewLink (WLanguage::BACK_TO_LIST, (WSystem::getParam ("view_prev")!="init" ?  WSystem::getParam ("view_prev") : "")) : "");
		}
		

	}

	public function getNewData () {
	
		if ($this->logic->fTreeView) {
			$values["parent_".$this->props["primary_column"]]=$this->connector->getPrimaryId ();
			return $values;
		}
		return NULL; // NULL = default data
	}
	
	public function getEditData () {		

		if (!$this->connector->getPrimaryId())
			return NULL;
			
		return $this->logic->select ($this->connector->getPrimaryId ());
	}

	private function initUploadedFiles (&$values) {

		
		foreach ($this->logic->fileDef as $field => $fieldProps) {
			if ($this->isUploadFile ($field)) {
				$filename = UPLOAD_PATH."/".$this->getUploadFilename ($field);
				$values[$field."_tmp"] = $this->getUploadFilename ($field);
				$values[$field."_orig"] = $this->getUploadFilename ($field, true);
				$values[$field."_size"]=filesize ($filename);
				$values[$field."_ext"]=strtoupper(WUtils::getFileExtension ($filename));		
				$values[$field."_date"]=WDB::getDate ();
			}
		}
	}

	public function insert ($values) {

		// Init upload files
		$this->initUploadedFiles ($values);

		// Insert into db
		$primary_id = $this->logic->insert ($values);
		if ($primary_id===false) {
			$this->errText = $this->logic->errText;
			return false;
		}
		
		// Update connector
		$this->connector->insert ($values);	
		
		return empty ($this->errText);
	}
	
	public function update ($values) {	
		
		// Check primary key equal with connector
		$primary_id = $values[$this->props["primary_column"]];
		$primary_id2 = $this->connector->getPrimaryId ();
		if (!$primary_id || $primary_id!=$primary_id2) {
			// Ooops, primary key is different
			$this->errText = WLanguage::SESSION_INCOMPATIBLE;
			return false;
		}

		// Init upload files
		$this->initUploadedFiles ($values);		
		
		// Update db
		if (!$this->logic->update ($primary_id, $values)) {
			$this->errText = $this->logic->errText;
			return false;
		}		
	
		// Update connector ...
		$this->connector->update ($values);

		if (empty ($this->errText)) {
			$this->successText = WSystem::getArrayValue ($this->props, "texts", "", "update_success");
			
			$this->updateInputValues ($values);
			return true;			
		}
			
		return false;
	}

	public function search ($values) {		
		return false;
	}
	
	public function delete ($values) {

		// Check primary key equal with connector
		$primary_id = $values[$this->props["primary_column"]];
		$primary_id2 = $this->connector->getPrimaryId ();
		if (!$primary_id || $primary_id!=$primary_id2) {
			// Ooops, primary key is different
			$this->errText = WLanguage::SESSION_INCOMPATIBLE;
			return false;
		}
		
		// Delete from db
		if (!$this->logic->delete ($primary_id, $values)) {
			$this->errText = $this->logic->errText;
			return false;
		}
		
		// Delete from connector
		$this->connector->delete ();

		$this->successText = WUtils::templateText (WSystem::getArrayValue ($this->props, "texts",  WLanguage::ENTRY_WAS_DELETED, "delete_success"), $values);
		return true;
	}
	


}



?>