<?php

class BrowserInfo
{

	private $browserInfo = array ();

	public function __construct ()
	{
    $u_agent = $_SERVER['HTTP_USER_AGENT'];
    $bname = 'Unknown';
    $ub = 'Unknown';
    $platform = 'Unknown';
    $version= "";

    //First get the platform?
    if (preg_match('/android/i', $u_agent)) {
        $platform = 'android';
    }
    else
		if (preg_match('/linux/i', $u_agent)) {
        $platform = 'linux';
    }
    elseif (preg_match('/macintosh|mac os x/i', $u_agent)) {
        $platform = 'mac';
    }
    elseif (preg_match('/windows|win32/i', $u_agent)) {
        $platform = 'windows';
    }
   
    // Next get the name of the useragent yes seperately and for good reason
    if(preg_match('/MSIE/i',$u_agent) && !preg_match('/Opera/i',$u_agent))
    {
        $bname = 'Internet Explorer';
        $ub = "MSIE";
    }
    elseif(preg_match('/Firefox/i',$u_agent))
    {
        $bname = 'Mozilla Firefox';
        $ub = "Firefox";
    }
    elseif(preg_match('/Chrome/i',$u_agent))
    {
        $bname = 'Google Chrome';
        $ub = "Chrome";
    }
    elseif(preg_match('/Safari/i',$u_agent))
    {
        $bname = 'Apple Safari';
        $ub = "Safari";
    }
    elseif(preg_match('/Opera/i',$u_agent))
    {
        $bname = 'Opera';
        $ub = "Opera";
    }
    elseif(preg_match('/Netscape/i',$u_agent))
    {
        $bname = 'Netscape';
        $ub = "Netscape";
    }
   
    // finally get the correct version number
    $known = array('Version', $ub, 'other');
    $pattern = '#(?<browser>' . join('|', $known) .
    ')[/ ]+(?<version>[0-9.|a-zA-Z.]*)#';
    if (!preg_match_all($pattern, $u_agent, $matches)) {
        // we have no matching number just continue
    }
    
    
   
    // see how many we have
    $i = count($matches['browser']);
    $version = "";
    if ($i != 1) {
      //we will have two since we are not using 'other' argument yet
      //see if version is before or after the name
      if (strripos($u_agent,"Version") < strripos($u_agent,$ub)){
          $version= $matches['version'][0];
      }
      else {
          $version= $matches['version'][1];
      }
    }
    else {
        $version= $matches['version'][0];
    }
   

   	$this->browserInfo = array(
        'userAgent' => $u_agent,
        'name'      => $bname,
        'name2'     => $ub,
        'version'   => $version,
        'platform'  => $platform,
        'pattern'   => $pattern
    );
	} 
	
	public function getName ($fShort=true) {
		if ($fShort) {
			if (isset ($this->browserInfo["name2"]))
				return $this->browserInfo["name2"];
		}
		else
		if (isset ($this->browserInfo["name"]))
			return $this->browserInfo["name"];
		return "";
	}
	
	public function getVersion () {
		if (isset ($this->browserInfo["version"]))
			return $this->browserInfo["version"];
		return "";
	}
	
	public function isIE () {
		return $this->getName ()=="MSIE";
	}

	public function isCSS3 () {
		/*
		switch ($this->browserInfo["name2"]) {
			case "Safari":
				return $this->browserInfo["version"]>=5;
				break;
			case "Chrome":
				return $this->browserInfo["version"]>=14;
				break;
			case "Firefox":
				return $this->browserInfo["version"]>=10;
				break;
			case "MSIE":
				return $this->browserInfo["version"]>=9;
				break;
		}
		*/
		return false;
	}
}



?>